libstdc++: std::basic_string< _CharT, _Traits, _Alloc > Class Template Reference

libstdc++

std::basic_string< _CharT, _Traits, _Alloc > Class Template Reference
Strings | Containers » Sequences

`#include <string>`

Inheritance diagram for std::basic_string< _CharT, _Traits, _Alloc >:
[legend]

## Public Types
typedef _Char_alloc_type | allocator_type
typedef _Alloc | allocator_type
typedef __gnu_cxx::__normal_iterator< const_pointer, basic_string > | const_iterator
typedef __gnu_cxx::__normal_iterator< const_pointer, basic_string > | const_iterator
typedef _Alloc_traits::const_pointer | const_pointer
typedef _CharT_alloc_traits::const_pointer | const_pointer
typedef _Alloc_traits::const_reference | const_reference
typedef const value_type & | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef _Alloc_traits::difference_type | difference_type
typedef _CharT_alloc_traits::difference_type | difference_type
typedef __gnu_cxx::__normal_iterator< pointer, basic_string > | iterator
typedef __gnu_cxx::__normal_iterator< pointer, basic_string > | iterator
typedef _Alloc_traits::pointer | pointer
typedef _CharT_alloc_traits::pointer | pointer
typedef _Alloc_traits::reference | reference
typedef value_type & | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef _Alloc_traits::size_type | size_type
typedef _CharT_alloc_traits::size_type | size_type
typedef _Traits | traits_type
typedef _Traits | traits_type
typedef _Traits::char_type | value_type
typedef _Traits::char_type | value_type

## Public Member Functions
| basic_string () noexcept
constexpr | basic_string () noexcept(/*conditional */)
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
constexpr | basic_string (_InputIterator __beg, _InputIterator __end, const _Alloc &__a=_Alloc())
template<class _InputIterator>
| basic_string (_InputIterator __beg, _InputIterator __end, const _Alloc &__a=_Alloc())
constexpr | basic_string (basic_string &&__str) noexcept
| basic_string (basic_string &&__str) noexcept
| basic_string (basic_string &&__str, const _Alloc &__a)
constexpr | basic_string (basic_string &&__str, const _Alloc &__a) noexcept(_Alloc_traits::_S_always_equal())
constexpr | basic_string (basic_string &&__str, size_type __pos, const _Alloc &__a=_Alloc())
constexpr | basic_string (basic_string &&__str, size_type __pos, size_type __n, const _Alloc &__a=_Alloc())
| basic_string (const _Alloc &__a)
constexpr | basic_string (const _Alloc &__a) noexcept
template<typename = _RequireAllocator<_Alloc>>
constexpr | basic_string (const _CharT *__s, const _Alloc &__a=_Alloc())
template<typename = _RequireAllocator<_Alloc>>
| basic_string (const _CharT *__s, const _Alloc &__a=_Alloc())
constexpr | basic_string (const _CharT *__s, size_type __n, const _Alloc &__a=_Alloc())
| basic_string (const _CharT *__s, size_type __n, const _Alloc &__a=_Alloc())
constexpr | basic_string (const basic_string &__str)
| basic_string (const basic_string &__str)
constexpr | basic_string (const basic_string &__str, const _Alloc &__a)
| basic_string (const basic_string &__str, const _Alloc &__a)
constexpr | basic_string (const basic_string &__str, size_type __pos, const _Alloc &__a=_Alloc())
| basic_string (const basic_string &__str, size_type __pos, const _Alloc &__a=_Alloc())
constexpr | basic_string (const basic_string &__str, size_type __pos, size_type __n)
| basic_string (const basic_string &__str, size_type __pos, size_type __n)
constexpr | basic_string (const basic_string &__str, size_type __pos, size_type __n, const _Alloc &__a)
| basic_string (const basic_string &__str, size_type __pos, size_type __n, const _Alloc &__a)
constexpr | basic_string (initializer_list< _CharT > __l, const _Alloc &__a=_Alloc())
| basic_string (initializer_list< _CharT > __l, const _Alloc &__a=_Alloc())
| basic_string (nullptr_t)=delete
| basic_string (nullptr_t)=delete
template<typename = _RequireAllocator<_Alloc>>
constexpr | basic_string (size_type __n, _CharT __c, const _Alloc &__a=_Alloc())
| basic_string (size_type __n, _CharT __c, const _Alloc &__a=_Alloc())
constexpr | ~basic_string ()
| ~basic_string () noexcept
template<typename _Operation>
constexpr void | __resize_and_overwrite (size_type __n, _Operation __op)
template<typename _Operation>
void | __resize_and_overwrite (size_type __n, _Operation __op)
template<typename _InputIterator>
basic_string< _CharT, _Traits, _Alloc > & | _M_replace_dispatch (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2, __false_type)
template<typename _InIterator>
_CharT * | _S_construct (_InIterator __beg, _InIterator __end, const _Alloc &__a, forward_iterator_tag)
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
constexpr basic_string & | append (_InputIterator __first, _InputIterator __last)
template<class _InputIterator>
basic_string & | append (_InputIterator __first, _InputIterator __last)
constexpr basic_string & | append (const _CharT *__s)
basic_string & | append (const _CharT *__s)
constexpr basic_string & | append (const _CharT *__s, size_type __n)
basic_string & | append (const _CharT *__s, size_type __n)
constexpr basic_string & | append (const basic_string &__str)
basic_string & | append (const basic_string &__str)
constexpr basic_string & | append (const basic_string &__str, size_type __pos, size_type __n=npos)
basic_string & | append (const basic_string &__str, size_type __pos, size_type __n=npos)
constexpr basic_string & | append (initializer_list< _CharT > __l)
basic_string & | append (initializer_list< _CharT > __l)
constexpr basic_string & | append (size_type __n, _CharT __c)
basic_string & | append (size_type __n, _CharT __c)
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
constexpr basic_string & | assign (_InputIterator __first, _InputIterator __last)
template<class _InputIterator>
basic_string & | assign (_InputIterator __first, _InputIterator __last)
constexpr basic_string & | assign (basic_string &&__str) noexcept(_Alloc_traits::_S_nothrow_move())
basic_string & | assign (basic_string &&__str) noexcept(allocator_traits< _Alloc >::is_always_equal::value)
constexpr basic_string & | assign (const _CharT *__s)
basic_string & | assign (const _CharT *__s)
constexpr basic_string & | assign (const _CharT *__s, size_type __n)
basic_string & | assign (const _CharT *__s, size_type __n)
constexpr basic_string & | assign (const basic_string &__str)
basic_string & | assign (const basic_string &__str)
constexpr basic_string & | assign (const basic_string &__str, size_type __pos, size_type __n=npos)
basic_string & | assign (const basic_string &__str, size_type __pos, size_type __n=npos)
constexpr basic_string & | assign (initializer_list< _CharT > __l)
basic_string & | assign (initializer_list< _CharT > __l)
constexpr basic_string & | assign (size_type __n, _CharT __c)
basic_string & | assign (size_type __n, _CharT __c)
constexpr reference | at (size_type __n)
reference | at (size_type __n)
constexpr const_reference | at (size_type __n) const
const_reference | at (size_type __n) const
reference | back ()
constexpr const_reference | back () const noexcept
const_reference | back () const noexcept
constexpr reference | back () noexcept
iterator | begin ()
constexpr const_iterator | begin () const noexcept
const_iterator | begin () const noexcept
constexpr iterator | begin () noexcept
constexpr const _CharT * | c_str () const noexcept
const _CharT * | c_str () const noexcept
constexpr size_type | capacity () const noexcept
size_type | capacity () const noexcept
constexpr const_iterator | cbegin () const noexcept
const_iterator | cbegin () const noexcept
constexpr const_iterator | cend () const noexcept
const_iterator | cend () const noexcept
constexpr void | clear () noexcept
void | clear () noexcept
constexpr int | compare (const _CharT *__s) const noexcept
int | compare (const _CharT *__s) const noexcept
constexpr int | compare (const basic_string &__str) const
int | compare (const basic_string &__str) const
constexpr int | compare (size_type __pos, size_type __n, const basic_string &__str) const
int | compare (size_type __pos, size_type __n, const basic_string &__str) const
constexpr int | compare (size_type __pos, size_type __n1, const _CharT *__s) const
int | compare (size_type __pos, size_type __n1, const _CharT *__s) const
constexpr int | compare (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2) const
int | compare (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2) const
constexpr int | compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos) const
int | compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos) const
constexpr bool | contains (_CharT __x) const noexcept
bool | contains (_CharT __x) const noexcept
constexpr bool | contains (basic_string_view< _CharT, _Traits > __x) const noexcept
bool | contains (basic_string_view< _CharT, _Traits > __x) const noexcept
constexpr bool | contains (const _CharT *__x) const noexcept
bool | contains (const _CharT *__x) const noexcept
constexpr size_type | copy (_CharT *__s, size_type __n, size_type __pos=0) const
size_type | copy (_CharT *__s, size_type __n, size_type __pos=0) const
constexpr const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crbegin () const noexcept
constexpr const_reverse_iterator | crend () const noexcept
const_reverse_iterator | crend () const noexcept
constexpr const _CharT * | data () const noexcept
const _CharT * | data () const noexcept
constexpr _CharT * | data () noexcept
_CharT * | data () noexcept(false)
constexpr bool | empty () const noexcept
bool | empty () const noexcept
iterator | end ()
constexpr const_iterator | end () const noexcept
const_iterator | end () const noexcept
constexpr iterator | end () noexcept
constexpr bool | ends_with (_CharT __x) const noexcept
bool | ends_with (_CharT __x) const noexcept
constexpr bool | ends_with (basic_string_view< _CharT, _Traits > __x) const noexcept
bool | ends_with (basic_string_view< _CharT, _Traits > __x) const noexcept
constexpr bool | ends_with (const _CharT *__x) const noexcept
bool | ends_with (const _CharT *__x) const noexcept
constexpr iterator | erase (__const_iterator __first, __const_iterator __last)
constexpr iterator | erase (__const_iterator __position)
iterator | erase (iterator __first, iterator __last)
iterator | erase (iterator __position)
constexpr basic_string & | erase (size_type __pos=0, size_type __n=npos)
basic_string & | erase (size_type __pos=0, size_type __n=npos)
constexpr size_type | find (_CharT __c, size_type __pos=0) const noexcept
size_type | find (_CharT __c, size_type __pos=0) const noexcept
constexpr size_type | find (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | find (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find (const _CharT *__s, size_type __pos=0) const noexcept
size_type | find (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find (const basic_string &__str, size_type __pos=0) const noexcept
constexpr size_type | find_first_not_of (_CharT __c, size_type __pos=0) const noexcept
size_type | find_first_not_of (_CharT __c, size_type __pos=0) const noexcept
constexpr size_type | find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_first_not_of (const _CharT *__s, size_type __pos=0) const noexcept
size_type | find_first_not_of (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find_first_not_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_not_of (const basic_string &__str, size_type __pos=0) const noexcept
constexpr size_type | find_first_of (_CharT __c, size_type __pos=0) const noexcept
size_type | find_first_of (_CharT __c, size_type __pos=0) const noexcept
constexpr size_type | find_first_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | find_first_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_first_of (const _CharT *__s, size_type __pos=0) const noexcept
size_type | find_first_of (const _CharT *__s, size_type __pos=0) const noexcept
constexpr size_type | find_first_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_of (const basic_string &__str, size_type __pos=0) const noexcept
constexpr size_type | find_last_not_of (_CharT __c, size_type __pos=npos) const noexcept
size_type | find_last_not_of (_CharT __c, size_type __pos=npos) const noexcept
constexpr size_type | find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_last_not_of (const _CharT *__s, size_type __pos=npos) const noexcept
size_type | find_last_not_of (const _CharT *__s, size_type __pos=npos) const noexcept
constexpr size_type | find_last_not_of (const basic_string &__str, size_type __pos=npos) const noexcept
size_type | find_last_not_of (const basic_string &__str, size_type __pos=npos) const noexcept
constexpr size_type | find_last_of (_CharT __c, size_type __pos=npos) const noexcept
size_type | find_last_of (_CharT __c, size_type __pos=npos) const noexcept
constexpr size_type | find_last_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | find_last_of (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | find_last_of (const _CharT *__s, size_type __pos=npos) const noexcept
size_type | find_last_of (const _CharT *__s, size_type __pos=npos) const noexcept
constexpr size_type | find_last_of (const basic_string &__str, size_type __pos=npos) const noexcept
size_type | find_last_of (const basic_string &__str, size_type __pos=npos) const noexcept
reference | front ()
constexpr const_reference | front () const noexcept
const_reference | front () const noexcept
constexpr reference | front () noexcept
constexpr allocator_type | get_allocator () const noexcept
allocator_type | get_allocator () const noexcept
constexpr iterator | insert (__const_iterator __p, _CharT __c)
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
constexpr iterator | insert (const_iterator __p, _InputIterator __beg, _InputIterator __end)
constexpr iterator | insert (const_iterator __p, initializer_list< _CharT > __l)
constexpr iterator | insert (const_iterator __p, size_type __n, _CharT __c)
iterator | insert (iterator __p, _CharT __c)
template<class _InputIterator>
void | insert (iterator __p, _InputIterator __beg, _InputIterator __end)
void | insert (iterator __p, initializer_list< _CharT > __l)
void | insert (iterator __p, size_type __n, _CharT __c)
constexpr basic_string & | insert (size_type __pos, const _CharT *__s)
basic_string & | insert (size_type __pos, const _CharT *__s)
constexpr basic_string & | insert (size_type __pos, const _CharT *__s, size_type __n)
basic_string & | insert (size_type __pos, const _CharT *__s, size_type __n)
constexpr basic_string & | insert (size_type __pos, size_type __n, _CharT __c)
basic_string & | insert (size_type __pos, size_type __n, _CharT __c)
constexpr basic_string & | insert (size_type __pos1, const basic_string &__str)
basic_string & | insert (size_type __pos1, const basic_string &__str)
constexpr basic_string & | insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n=npos)
basic_string & | insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n=npos)
constexpr size_type | length () const noexcept
size_type | length () const noexcept
constexpr size_type | max_size () const noexcept
size_type | max_size () const noexcept
constexpr basic_string & | operator+= (_CharT __c)
basic_string & | operator+= (_CharT __c)
constexpr basic_string & | operator+= (const _CharT *__s)
basic_string & | operator+= (const _CharT *__s)
constexpr basic_string & | operator+= (const basic_string &__str)
basic_string & | operator+= (const basic_string &__str)
constexpr basic_string & | operator+= (initializer_list< _CharT > __l)
basic_string & | operator+= (initializer_list< _CharT > __l)
constexpr basic_string & | operator= (_CharT __c)
basic_string & | operator= (_CharT __c)
basic_string & | operator= (basic_string &&__str) noexcept(/*conditional */)
constexpr basic_string & | operator= (basic_string &&__str) noexcept(_Alloc_traits::_S_nothrow_move())
constexpr basic_string & | operator= (const _CharT *__s)
basic_string & | operator= (const _CharT *__s)
constexpr basic_string & | operator= (const basic_string &__str)
basic_string & | operator= (const basic_string &__str)
constexpr basic_string & | operator= (initializer_list< _CharT > __l)
basic_string & | operator= (initializer_list< _CharT > __l)
basic_string & | operator= (nullptr_t)=delete
basic_string & | operator= (nullptr_t)=delete
constexpr reference | operator[] (size_type __pos)
reference | operator[] (size_type __pos)
constexpr const_reference | operator[] (size_type __pos) const noexcept
const_reference | operator[] (size_type __pos) const noexcept
void | pop_back ()
constexpr void | pop_back () noexcept
constexpr void | push_back (_CharT __c)
void | push_back (_CharT __c)
reverse_iterator | rbegin ()
constexpr const_reverse_iterator | rbegin () const noexcept
const_reverse_iterator | rbegin () const noexcept
constexpr reverse_iterator | rbegin () noexcept
reverse_iterator | rend ()
constexpr const_reverse_iterator | rend () const noexcept
const_reverse_iterator | rend () const noexcept
constexpr reverse_iterator | rend () noexcept
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, _CharT *__k1, _CharT *__k2)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const _CharT *__k1, const _CharT *__k2)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const _CharT *__s)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const _CharT *__s, size_type __n)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const basic_string &__str)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const_iterator __k1, const_iterator __k2)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, iterator __k1, iterator __k2)
constexpr basic_string & | replace (__const_iterator __i1, __const_iterator __i2, size_type __n, _CharT __c)
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
constexpr basic_string & | replace (const_iterator __i1, const_iterator __i2, _InputIterator __k1, _InputIterator __k2)
constexpr basic_string & | replace (const_iterator __i1, const_iterator __i2, initializer_list< _CharT > __l)
basic_string & | replace (iterator __i1, iterator __i2, _CharT *__k1, _CharT *__k2)
template<class _InputIterator>
basic_string & | replace (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__k1, const _CharT *__k2)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s, size_type __n)
basic_string & | replace (iterator __i1, iterator __i2, const basic_string &__str)
basic_string & | replace (iterator __i1, iterator __i2, const_iterator __k1, const_iterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, initializer_list< _CharT > __l)
basic_string & | replace (iterator __i1, iterator __i2, iterator __k1, iterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, size_type __n, _CharT __c)
constexpr basic_string & | replace (size_type __pos, size_type __n, const basic_string &__str)
basic_string & | replace (size_type __pos, size_type __n, const basic_string &__str)
constexpr basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s)
basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s)
constexpr basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2)
basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2)
constexpr basic_string & | replace (size_type __pos, size_type __n1, size_type __n2, _CharT __c)
basic_string & | replace (size_type __pos, size_type __n1, size_type __n2, _CharT __c)
constexpr basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos)
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos)
constexpr void | reserve ()
void | reserve ()
constexpr void | reserve (size_type __res_arg)
void | reserve (size_type __res_arg)
constexpr void | resize (size_type __n)
void | resize (size_type __n)
constexpr void | resize (size_type __n, _CharT __c)
void | resize (size_type __n, _CharT __c)
constexpr size_type | rfind (_CharT __c, size_type __pos=npos) const noexcept
size_type | rfind (_CharT __c, size_type __pos=npos) const noexcept
constexpr size_type | rfind (const _CharT *__s, size_type __pos, size_type __n) const noexcept
size_type | rfind (const _CharT *__s, size_type __pos, size_type __n) const noexcept
constexpr size_type | rfind (const _CharT *__s, size_type __pos=npos) const
size_type | rfind (const _CharT *__s, size_type __pos=npos) const noexcept
constexpr size_type | rfind (const basic_string &__str, size_type __pos=npos) const noexcept
size_type | rfind (const basic_string &__str, size_type __pos=npos) const noexcept
constexpr void | shrink_to_fit () noexcept
void | shrink_to_fit () noexcept
constexpr size_type | size () const noexcept
size_type | size () const noexcept
constexpr bool | starts_with (_CharT __x) const noexcept
bool | starts_with (_CharT __x) const noexcept
constexpr bool | starts_with (basic_string_view< _CharT, _Traits > __x) const noexcept
bool | starts_with (basic_string_view< _CharT, _Traits > __x) const noexcept
constexpr bool | starts_with (const _CharT *__x) const noexcept
bool | starts_with (const _CharT *__x) const noexcept
constexpr basic_string | substr (size_type __pos, size_type __n) &&
constexpr basic_string | substr (size_type __pos=0) &&
constexpr basic_string | substr (size_type __pos=0, size_type __n=npos) const
basic_string | substr (size_type __pos=0, size_type __n=npos) const
constexpr basic_string_view< _CharT, _Traits > | subview (size_type __pos=0, size_type __n=npos) const
constexpr basic_string_view< _CharT, _Traits > | subview (size_type __pos=0, size_type __n=npos) const
constexpr void | swap (basic_string &__s) noexcept
void | swap (basic_string &__s) noexcept(/*conditional */)

## Static Public Attributes
static const size_type | npos

## Protected Types
typedef const_iterator | __const_iterator
typedef iterator | __const_iterator

## Friends
template<typename, typename, typename>
class | basic_stringbuf

## Detailed Description

template<typename _CharT, typename _Traits, typename _Alloc>
class std::basic_string< _CharT, _Traits, _Alloc >

Managing sequences of characters and character-like objects.

Since
  C++98

Template Parameters

  _CharT | Type of character
  _Traits | Traits for character type, defaults to char_traits<_CharT>.
  _Alloc | Allocator type, defaults to allocator<_CharT>.

Meets the requirements of a container, a reversible container, and a sequence. Of the optional sequence requirements, only `push_back`, `at`, and `array` access are supported.

Since
  C++98

Template Parameters

  _CharT | Type of character
  _Traits | Traits for character type, defaults to char_traits<_CharT>.
  _Alloc | Allocator type, defaults to allocator<_CharT>.

Meets the requirements of a container, a reversible container, and a sequence. Of the optional sequence requirements, only `push_back`, `at`, and `array` access are supported.

Todo
  Needs documentation! See http://gcc.gnu.org/onlinedocs/libstdc++/manual/documentation_style.html

Documentation? What's that? Nathan Myers ncm@c.nosp@m.antr.nosp@m.ip.or.nosp@m.g.

A string looks like this:

[_Rep]
_M_length
[basic_string<char_type>] _M_capacity
_M_dataplus _M_refcount
_M_p ----------------> unnamed array of char_type
std::array
A standard container for storing a fixed size sequence of elements.
Definition array:104
std::basic_string::basic_string
constexpr basic_string() noexcept(/*conditional */)
Default constructor creates an empty string.
Definition basic_string.h:619

Where the _M_p points to the first character in the string, and you cast it to a pointer-to-_Rep and subtract 1 to get a pointer to the header.

This approach has the enormous advantage that a string object requires only one allocation. All the ugliness is confined within a single pair of inline functions, which each compile to a single add instruction: _Rep::_M_data(), and string::_M_rep(); and the allocation function which gets a block of raw bytes and with room enough and constructs a _Rep object at the front.

The reason you want _M_data pointing to the character array and not the _Rep is so that the debugger can see the string contents. (Probably we should add a non-inline member to get the _Rep for the debugger to use, so users can check the actual string length.)

Note that the _Rep object is a POD so that you can have a static empty string _Rep object already constructed before static constructors have run. The reference-count encoding is chosen so that a 0 indicates one reference, so you never try to destroy the empty-string _Rep object.

All but the last paragraph is considered pretty conventional for a Copy-On-Write C++ string implementation.

Definition at line 93 of file basic_string.h.

## Member Typedef Documentation

## ◆ __const_iterator [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef const_iterator std::basic_string< _CharT, _Traits, _Alloc >::__const_iterator
| protected

Definition at line 134 of file basic_string.h.

## ◆ __const_iterator [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef iterator std::basic_string< _CharT, _Traits, _Alloc >::__const_iterator
| protected

Definition at line 138 of file cow_string.h.

## ◆ allocator_type [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Char_alloc_type std::basic_string< _CharT, _Traits, _Alloc >::allocator_type

Definition at line 113 of file basic_string.h.

## ◆ allocator_type [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Alloc std::basic_string< _CharT, _Traits, _Alloc >::allocator_type

Definition at line 118 of file cow_string.h.

## ◆ const_iterator [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef __gnu_cxx::__normal_iterator<const_pointer, basic_string> std::basic_string< _CharT, _Traits, _Alloc >::const_iterator

Definition at line 122 of file basic_string.h.

## ◆ const_iterator [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef __gnu_cxx::__normal_iterator<const_pointer, basic_string> std::basic_string< _CharT, _Traits, _Alloc >::const_iterator

Definition at line 132 of file cow_string.h.

## ◆ const_pointer [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Alloc_traits::const_pointer std::basic_string< _CharT, _Traits, _Alloc >::const_pointer

Definition at line 119 of file basic_string.h.

## ◆ const_pointer [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _CharT_alloc_traits::const_pointer std::basic_string< _CharT, _Traits, _Alloc >::const_pointer

Definition at line 129 of file cow_string.h.

## ◆ const_reference [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Alloc_traits::const_reference std::basic_string< _CharT, _Traits, _Alloc >::const_reference

Definition at line 117 of file basic_string.h.

## ◆ const_reference [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef const value_type& std::basic_string< _CharT, _Traits, _Alloc >::const_reference

Definition at line 126 of file cow_string.h.

## ◆ const_reverse_iterator [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef std::reverse_iterator<const_iterator> std::basic_string< _CharT, _Traits, _Alloc >::const_reverse_iterator

Definition at line 123 of file basic_string.h.

## ◆ const_reverse_iterator [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef std::reverse_iterator<const_iterator> std::basic_string< _CharT, _Traits, _Alloc >::const_reverse_iterator

Definition at line 133 of file cow_string.h.

## ◆ difference_type [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Alloc_traits::difference_type std::basic_string< _CharT, _Traits, _Alloc >::difference_type

Definition at line 115 of file basic_string.h.

## ◆ difference_type [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _CharT_alloc_traits::difference_type std::basic_string< _CharT, _Traits, _Alloc >::difference_type

Definition at line 120 of file cow_string.h.

## ◆ iterator [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef __gnu_cxx::__normal_iterator<pointer, basic_string> std::basic_string< _CharT, _Traits, _Alloc >::iterator

Definition at line 120 of file basic_string.h.

## ◆ iterator [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef __gnu_cxx::__normal_iterator<pointer, basic_string> std::basic_string< _CharT, _Traits, _Alloc >::iterator

Definition at line 130 of file cow_string.h.

## ◆ pointer [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Alloc_traits::pointer std::basic_string< _CharT, _Traits, _Alloc >::pointer

Definition at line 118 of file basic_string.h.

## ◆ pointer [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _CharT_alloc_traits::pointer std::basic_string< _CharT, _Traits, _Alloc >::pointer

Definition at line 128 of file cow_string.h.

## ◆ reference [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Alloc_traits::reference std::basic_string< _CharT, _Traits, _Alloc >::reference

Definition at line 116 of file basic_string.h.

## ◆ reference [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef value_type& std::basic_string< _CharT, _Traits, _Alloc >::reference

Definition at line 125 of file cow_string.h.

## ◆ reverse_iterator [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef std::reverse_iterator<iterator> std::basic_string< _CharT, _Traits, _Alloc >::reverse_iterator

Definition at line 124 of file basic_string.h.

## ◆ reverse_iterator [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef std::reverse_iterator<iterator> std::basic_string< _CharT, _Traits, _Alloc >::reverse_iterator

Definition at line 134 of file cow_string.h.

## ◆ size_type [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Alloc_traits::size_type std::basic_string< _CharT, _Traits, _Alloc >::size_type

Definition at line 114 of file basic_string.h.

## ◆ size_type [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _CharT_alloc_traits::size_type std::basic_string< _CharT, _Traits, _Alloc >::size_type

Definition at line 119 of file cow_string.h.

## ◆ traits_type [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Traits std::basic_string< _CharT, _Traits, _Alloc >::traits_type

Definition at line 111 of file basic_string.h.

## ◆ traits_type [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Traits std::basic_string< _CharT, _Traits, _Alloc >::traits_type

Definition at line 116 of file cow_string.h.

## ◆ value_type [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Traits::char_type std::basic_string< _CharT, _Traits, _Alloc >::value_type

Definition at line 112 of file basic_string.h.

## ◆ value_type [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Traits::char_type std::basic_string< _CharT, _Traits, _Alloc >::value_type

Definition at line 117 of file cow_string.h.

## Constructor & Destructor Documentation

## ◆ basic_string() [1/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( |  | ) |
| inlineconstexprnoexcept

Default constructor creates an empty string.

Definition at line 619 of file basic_string.h.

Referenced by std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::substr(), and swap().

## ◆ basic_string() [2/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const _Alloc & | __a | ) |
| inlineexplicitconstexprnoexcept

Construct an empty string using allocator a.

Definition at line 635 of file basic_string.h.

## ◆ basic_string() [3/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |
| inlineconstexpr

Construct string with copy of value of __str.

Parameters

  __str | Source string.

Definition at line 647 of file basic_string.h.

## ◆ basic_string() [4/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | const _Alloc & | __a = _Alloc() )
| inlineconstexpr

Construct string as copy of a substring.

Parameters

  __str | Source string.
  __pos | Index of first character to copy from.
  __a | Allocator to use.

Definition at line 663 of file basic_string.h.

## ◆ basic_string() [5/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n )
| inlineconstexpr

Construct string as copy of a substring.

Parameters

  __str | Source string.
  __pos | Index of first character to copy from.
  __n | Number of characters to copy.

Definition at line 680 of file basic_string.h.

## ◆ basic_string() [6/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n,
|  | const _Alloc & | __a )
| inlineconstexpr

Construct string as copy of a substring.

Parameters

  __str | Source string.
  __pos | Index of first character to copy from.
  __n | Number of characters to copy.
  __a | Allocator to use.

Definition at line 698 of file basic_string.h.

## ◆ basic_string() [7/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | basic_string< _CharT, _Traits, _Alloc > && | __str,
|  | size_type | __pos,
|  | const _Alloc & | __a = _Alloc() )
| inlineconstexpr

Definition at line 710 of file basic_string.h.

## ◆ basic_string() [8/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | basic_string< _CharT, _Traits, _Alloc > && | __str,
|  | size_type | __pos,
|  | size_type | __n,
|  | const _Alloc & | __a = _Alloc() )
| inlineconstexpr

Definition at line 719 of file basic_string.h.

## ◆ basic_string() [9/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const _CharT * | __s,
|  | size_type | __n,
|  | const _Alloc & | __a = _Alloc() )
| inlineconstexpr

Construct string initialized by a character array.

Parameters

  __s | Source character array.
  __n | Number of characters to copy.
  __a | Allocator to use (default is default allocator).

NB: __s must have at least __n characters, '\0' has no special meaning.

Definition at line 738 of file basic_string.h.

## ◆ basic_string() [10/30]

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename = _RequireAllocator<_Alloc>>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const _CharT * | __s,
|  | const _Alloc & | __a = _Alloc() )
| inlineconstexpr

Construct string as copy of a C string.

Parameters

  __s | Source C string.
  __a | Allocator to use (default is default allocator).

Definition at line 760 of file basic_string.h.

## ◆ basic_string() [11/30]

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename = _RequireAllocator<_Alloc>>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | size_type | __n,
|  | _CharT | __c,
|  | const _Alloc & | __a = _Alloc() )
| inlineconstexpr

Construct string as multiple characters.

Parameters

  __n | Number of characters.
  __c | Character to use.
  __a | Allocator to use (default is default allocator).

Definition at line 783 of file basic_string.h.

## ◆ basic_string() [12/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | basic_string< _CharT, _Traits, _Alloc > && | __str | ) |
| inlineconstexprnoexcept

Move construct string.

Parameters

  __str | Source string.

The newly-created string contains the exact contents of __str. __str is a valid, but unspecified string.

Definition at line 796 of file basic_string.h.

## ◆ basic_string() [13/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | initializer_list< _CharT > | __l,
|  | const _Alloc & | __a = _Alloc() )
| inlineconstexpr

Construct string from an initializer list.

Parameters

  __l | std::initializer_list of characters.
  __a | Allocator to use (default is default allocator).

Definition at line 852 of file basic_string.h.

## ◆ basic_string() [14/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | const _Alloc & | __a )
| inlineconstexpr

Definition at line 857 of file basic_string.h.

## ◆ basic_string() [15/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | basic_string< _CharT, _Traits, _Alloc > && | __str,
|  | const _Alloc & | __a )
| inlineconstexprnoexcept

Definition at line 862 of file basic_string.h.

## ◆ basic_string() [16/30]

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | _InputIterator | __beg,
|  | _InputIterator | __end,
|  | const _Alloc & | __a = _Alloc() )
| inlineconstexpr

Construct string as copy of a range.

Parameters

  __beg | Start of range.
  __end | End of range.
  __a | Allocator to use (default is default allocator).

Definition at line 906 of file basic_string.h.

## ◆ ~basic_string() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::~basic_string | ( |  | ) |
| inlineconstexpr

Destroy the string instance.

Definition at line 949 of file basic_string.h.

## ◆ basic_string() [17/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( |  | ) |
| inlinenoexcept

Default constructor creates an empty string.

Definition at line 515 of file cow_string.h.

## ◆ basic_string() [18/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const _Alloc & | __a | ) |
| inlineexplicit

Construct an empty string using allocator a.

Definition at line 533 of file cow_string.h.

## ◆ basic_string() [19/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |
| inline

Construct string with copy of value of str.

Parameters

  __str | Source string.

Definition at line 542 of file cow_string.h.

## ◆ basic_string() [20/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | const _Alloc & | __a = _Alloc() )

Construct string as copy of a substring.

Parameters

  __str | Source string.
  __pos | Index of first character to copy from.
  __a | Allocator to use.

## ◆ basic_string() [21/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n )

Construct string as copy of a substring.

Parameters

  __str | Source string.
  __pos | Index of first character to copy from.
  __n | Number of characters to copy.

## ◆ basic_string() [22/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n,
|  | const _Alloc & | __a )

Construct string as copy of a substring.

Parameters

  __str | Source string.
  __pos | Index of first character to copy from.
  __n | Number of characters to copy.
  __a | Allocator to use.

## ◆ basic_string() [23/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const _CharT * | __s,
|  | size_type | __n,
|  | const _Alloc & | __a = _Alloc() )
| inline

Construct string initialized by a character array.

Parameters

  __s | Source character array.
  __n | Number of characters to copy.
  __a | Allocator to use (default is default allocator).

NB: __s must have at least __n characters, '\0' has no special meaning.

Definition at line 586 of file cow_string.h.

## ◆ basic_string() [24/30]

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename = _RequireAllocator<_Alloc>>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const _CharT * | __s,
|  | const _Alloc & | __a = _Alloc() )
| inline

Construct string as copy of a C string.

Parameters

  __s | Source C string.
  __a | Allocator to use (default is default allocator).

Definition at line 601 of file cow_string.h.

## ◆ basic_string() [25/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | size_type | __n,
|  | _CharT | __c,
|  | const _Alloc & | __a = _Alloc() )
| inline

Construct string as multiple characters.

Parameters

  __n | Number of characters.
  __c | Character to use.
  __a | Allocator to use (default is default allocator).

Definition at line 612 of file cow_string.h.

## ◆ basic_string() [26/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | basic_string< _CharT, _Traits, _Alloc > && | __str | ) |
| inlinenoexcept

Move construct string.

Parameters

  __str | Source string.

The newly-created string contains the exact contents of __str. __str is a valid, but unspecified string.

Definition at line 624 of file cow_string.h.

## ◆ basic_string() [27/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | initializer_list< _CharT > | __l,
|  | const _Alloc & | __a = _Alloc() )
| inline

Construct string from an initializer list.

Parameters

  __l | std::initializer_list of characters.
  __a | Allocator to use (default is default allocator).

Definition at line 689 of file cow_string.h.

## ◆ basic_string() [28/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | const _Alloc & | __a )
| inline

Definition at line 693 of file cow_string.h.

## ◆ basic_string() [29/30]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | basic_string< _CharT, _Traits, _Alloc > && | __str,
|  | const _Alloc & | __a )
| inline

Definition at line 697 of file cow_string.h.

## ◆ basic_string() [30/30]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator>

std::basic_string< _CharT, _Traits, _Alloc >::basic_string | ( | _InputIterator | __beg,
|  | _InputIterator | __end,
|  | const _Alloc & | __a = _Alloc() )
| inline

Construct string as copy of a range.

Parameters

  __beg | Start of range.
  __end | End of range.
  __a | Allocator to use (default is default allocator).

Definition at line 725 of file cow_string.h.

## ◆ ~basic_string() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc >::~basic_string | ( |  | ) |
| inlinenoexcept

Destroy the string instance.

Definition at line 758 of file cow_string.h.

## Member Function Documentation

## ◆ __resize_and_overwrite() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _Operation>

void std::basic_string< _CharT, _Traits, _Alloc >::__resize_and_overwrite | ( | size_type | __n,
|  | _Operation | __op )
| constexpr

Non-standard version of resize_and_overwrite for C++11 and above.

## ◆ __resize_and_overwrite() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _Operation>

void std::basic_string< _CharT, _Traits, _Alloc >::__resize_and_overwrite | ( | size_type | __n,
|  | _Operation | __op )

Non-standard version of resize_and_overwrite for C++11 and above.

## ◆ _M_replace_dispatch()

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _InputIterator>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::_M_replace_dispatch | ( | iterator | __i1,
|  | iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2,
|  | __false_type | )

Definition at line 3831 of file cow_string.h.

## ◆ _S_construct()

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _InIterator>

_CharT * std::basic_string< _CharT, _Traits, _Alloc >::_S_construct | ( | _InIterator | __beg,
|  | _InIterator | __end,
|  | const _Alloc & | __a,
|  | forward_iterator_tag | )

Definition at line 3328 of file cow_string.h.

## ◆ append() [1/14]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inlineconstexpr

Append a range of characters.

Parameters

  __first | Iterator referencing the first character to append.
  __last | Iterator marking the end of the range.

Returns
  Reference to this string.

Appends characters in the range [__first,__last) to this string.

Definition at line 1735 of file basic_string.h.

## ◆ append() [2/14]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inline

Append a range of characters.

Parameters

  __first | Iterator referencing the first character to append.
  __last | Iterator marking the end of the range.

Returns
  Reference to this string.

Appends characters in the range [__first,__last) to this string.

Definition at line 1396 of file cow_string.h.

## ◆ append() [3/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const _CharT * | __s | ) |
| inlineconstexpr

Append a C string.

Parameters

  __s | The C string to append.

Returns
  Reference to this string.

Definition at line 1634 of file basic_string.h.

## ◆ append() [4/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const _CharT * | __s | ) |
| inline

Append a C string.

Parameters

  __s | The C string to append.

Returns
  Reference to this string.

Definition at line 1342 of file cow_string.h.

## ◆ append() [5/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const _CharT * | __s,
|  | size_type | __n )
| inlineconstexpr

Append a C substring.

Parameters

  __s | The C string to append.
  __n | The number of characters to append.

Returns
  Reference to this string.

Definition at line 1620 of file basic_string.h.

## ◆ append() [6/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const _CharT * | __s,
|  | size_type | __n )

Append a C substring.

Parameters

  __s | The C string to append.
  __n | The number of characters to append.

Returns
  Reference to this string.

## ◆ append() [7/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |
| inlineconstexpr

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

Definition at line 1589 of file basic_string.h.

Referenced by std::basic_string< _CharT >::append(), std::basic_string< _CharT >::append(), std::basic_string< _CharT >::append(), std::basic_string< _CharT >::append(), std::__cxx11::collate< _CharT >::do_transform(), std::basic_string< _CharT >::operator+=(), std::basic_string< _CharT >::operator+=(), std::basic_string< _CharT >::operator+=(), std::operator>>(), std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > >::reserve(), and resize().

## ◆ append() [8/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

## ◆ append() [9/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n = npos )
| inlineconstexpr

Append a substring.

Parameters

  __str | The string to append.
  __pos | Index of the first character of str to append.
  __n | The number of characters to append.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if __pos is not a valid index.

This function appends __n characters from __str starting at __pos to this string. If __n is is larger than the number of available characters in __str, the remainder of __str is appended.

Definition at line 1607 of file basic_string.h.

## ◆ append() [10/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n = npos )

Append a substring.

Parameters

  __str | The string to append.
  __pos | Index of the first character of str to append.
  __n | The number of characters to append.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if __pos is not a valid index.

This function appends __n characters from __str starting at __pos to this string. If __n is is larger than the number of available characters in __str, the remainder of __str is appended.

## ◆ append() [11/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | initializer_list< _CharT > | __l | ) |
| inlineconstexpr

Append an initializer_list of characters.

Parameters

  __l | The initializer_list of characters to append.

Returns
  Reference to this string.

Definition at line 1715 of file basic_string.h.

## ◆ append() [12/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | initializer_list< _CharT > | __l | ) |
| inline

Append an initializer_list of characters.

Parameters

  __l | The initializer_list of characters to append.

Returns
  Reference to this string.

Definition at line 1382 of file cow_string.h.

## ◆ append() [13/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | size_type | __n,
|  | _CharT | __c )
| inlineconstexpr

Append multiple characters.

Parameters

  __n | The number of characters to append.
  __c | The character to use.

Returns
  Reference to this string.

Appends __n copies of __c to this string.

Definition at line 1652 of file basic_string.h.

## ◆ append() [14/14]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::append | ( | size_type | __n,
|  | _CharT | __c )

Append multiple characters.

Parameters

  __n | The number of characters to append.
  __c | The character to use.

Returns
  Reference to this string.

Appends __n copies of __c to this string.

## ◆ assign() [1/16]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inlineconstexpr

Set value to a range of characters.

Parameters

  __first | Iterator referencing the first character to append.
  __last | Iterator marking the end of the range.

Returns
  Reference to this string.

Sets value of string to characters in the range [__first,__last).

Definition at line 1934 of file basic_string.h.

## ◆ assign() [2/16]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inline

Set value to a range of characters.

Parameters

  __first | Iterator referencing the first character to append.
  __last | Iterator marking the end of the range.

Returns
  Reference to this string.

Sets value of string to characters in the range [__first,__last).

Definition at line 1543 of file cow_string.h.

## ◆ assign() [3/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | basic_string< _CharT, _Traits, _Alloc > && | __str | ) |
| inlineconstexprnoexcept

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

This function sets this string to the exact contents of __str. __str is a valid, but unspecified string.

Definition at line 1840 of file basic_string.h.

## ◆ assign() [4/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | basic_string< _CharT, _Traits, _Alloc > && | __str | ) |
| inlinenoexcept

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

This function sets this string to the exact contents of __str. __str is a valid, but unspecified string.

Definition at line 1464 of file cow_string.h.

## ◆ assign() [5/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const _CharT * | __s | ) |
| inlineconstexpr

Set value to contents of a C string.

Parameters

  __s | The C string to use.

Returns
  Reference to this string.

This function sets the value of this string to the value of __s. The data is copied, so there is no dependence on __s once the function returns.

Definition at line 1898 of file basic_string.h.

## ◆ assign() [6/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const _CharT * | __s | ) |
| inline

Set value to contents of a C string.

Parameters

  __s | The C string to use.

Returns
  Reference to this string.

This function sets the value of this string to the value of __s. The data is copied, so there is no dependence on __s once the function returns.

Definition at line 1514 of file cow_string.h.

## ◆ assign() [7/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const _CharT * | __s,
|  | size_type | __n )
| inlineconstexpr

Set value to a C substring.

Parameters

  __s | The C string to use.
  __n | Number of characters to use.

Returns
  Reference to this string.

This function sets the value of this string to the first __n characters of __s. If __n is is larger than the number of available characters in __s, the remainder of __s is used.

Definition at line 1881 of file basic_string.h.

## ◆ assign() [8/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const _CharT * | __s,
|  | size_type | __n )

Set value to a C substring.

Parameters

  __s | The C string to use.
  __n | Number of characters to use.

Returns
  Reference to this string.

This function sets the value of this string to the first __n characters of __s. If __n is is larger than the number of available characters in __s, the remainder of __s is used.

## ◆ assign() [9/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |
| inlineconstexpr

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

Definition at line 1794 of file basic_string.h.

Referenced by std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::operator=(), std::basic_string< _CharT >::operator=(), std::basic_string< _CharT >::operator=(), std::basic_string< _CharT >::operator=(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< char >::str(), and std::basic_stringbuf< char >::str().

## ◆ assign() [10/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

## ◆ assign() [11/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n = npos )
| inlineconstexpr

Set value to a substring of a string.

Parameters

  __str | The string to use.
  __pos | Index of the first character of str.
  __n | Number of characters to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if pos is not a valid index.

This function sets this string to the substring of __str consisting of __n characters at __pos. If __n is is larger than the number of available characters in __str, the remainder of __str is used.

Definition at line 1864 of file basic_string.h.

## ◆ assign() [12/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos,
|  | size_type | __n = npos )
| inline

Set value to a substring of a string.

Parameters

  __str | The string to use.
  __pos | Index of the first character of str.
  __n | Number of characters to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if pos is not a valid index.

This function sets this string to the substring of __str consisting of __n characters at __pos. If __n is is larger than the number of available characters in __str, the remainder of __str is used.

Definition at line 1486 of file cow_string.h.

## ◆ assign() [13/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | initializer_list< _CharT > | __l | ) |
| inlineconstexpr

Set value to an initializer_list of characters.

Parameters

  __l | The initializer_list of characters to assign.

Returns
  Reference to this string.

Definition at line 1993 of file basic_string.h.

## ◆ assign() [14/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | initializer_list< _CharT > | __l | ) |
| inline

Set value to an initializer_list of characters.

Parameters

  __l | The initializer_list of characters to assign.

Returns
  Reference to this string.

Definition at line 1569 of file cow_string.h.

## ◆ assign() [15/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | size_type | __n,
|  | _CharT | __c )
| inlineconstexpr

Set value to multiple characters.

Parameters

  __n | Length of the resulting string.
  __c | The character to use.

Returns
  Reference to this string.

This function sets the value of this string to __n copies of character __c.

Definition at line 1916 of file basic_string.h.

## ◆ assign() [16/16]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::assign | ( | size_type | __n,
|  | _CharT | __c )
| inline

Set value to multiple characters.

Parameters

  __n | Length of the resulting string.
  __c | The character to use.

Returns
  Reference to this string.

This function sets the value of this string to __n copies of character __c.

Definition at line 1530 of file cow_string.h.

## ◆ at() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::at | ( | size_type | __n | ) |
| inlinenodiscardconstexpr

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read/write reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 1463 of file basic_string.h.

## ◆ at() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::at | ( | size_type | __n | ) |
| inline

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read/write reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails. Success results in unsharing the string.

Definition at line 1192 of file cow_string.h.

## ◆ at() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::at | ( | size_type | __n | ) | const
| inlinenodiscardconstexpr

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read-only (const) reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 1441 of file basic_string.h.

## ◆ at() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::at | ( | size_type | __n | ) | const
| inline

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read-only (const) reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 1170 of file cow_string.h.

## ◆ back() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::back | ( |  | ) |
| inline

Returns a read/write reference to the data at the last element of the string.

Definition at line 1231 of file cow_string.h.

## ◆ back() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::back | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns a read-only (constant) reference to the data at the last element of the string.

Definition at line 1516 of file basic_string.h.

## ◆ back() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::back | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reference to the data at the last element of the string.

Definition at line 1242 of file cow_string.h.

## ◆ back() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::back | ( |  | ) |
| inlinenodiscardconstexprnoexcept

Returns a read/write reference to the data at the last element of the string.

Definition at line 1504 of file basic_string.h.

## ◆ begin() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::begin | ( |  | ) |
| inline

Returns a read/write iterator that points to the first character in the string. Unshares the string.

Definition at line 844 of file cow_string.h.

## ◆ begin() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::begin | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns a read-only (constant) iterator that points to the first character in the string.

Definition at line 1110 of file basic_string.h.

## ◆ begin() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::begin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points to the first character in the string.

Definition at line 855 of file cow_string.h.

## ◆ begin() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::begin | ( |  | ) |
| inlinenodiscardconstexprnoexcept

Returns a read/write iterator that points to the first character in the string.

Definition at line 1101 of file basic_string.h.

Referenced by std::basic_string< _CharT >::crend(), std::basic_string< _CharT >::erase(), std::basic_string< _CharT >::erase(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::regex_match(), std::regex_match(), std::regex_replace(), std::regex_replace(), std::regex_search(), std::basic_string< _CharT >::rend(), std::basic_string< _CharT >::rend(), std::basic_string< _CharT >::rend(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), and std::basic_string< _CharT >::replace().

## ◆ c_str() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

const _CharT * std::basic_string< _CharT, _Traits, _Alloc >::c_str | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Return const pointer to null-terminated contents.

This is a handle to internal data. Do not modify or dire things may happen.

Definition at line 2927 of file basic_string.h.

Referenced by std::__cxx11::collate< _CharT >::do_compare(), std::money_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::__cxx11::collate< _CharT >::do_transform(), std::basic_filebuf< char_type, traits_type >::open(), std::operator+(), std::operator+(), std::operator+(), std::operator+(), std::operator+(), std::regex_replace(), and std::regex_traits< _CharT >::transform_primary().

## ◆ c_str() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

const _CharT * std::basic_string< _CharT, _Traits, _Alloc >::c_str | ( |  | ) | const
| inlinenoexcept

Return const pointer to null-terminated contents.

This is a handle to internal data. Do not modify or dire things may happen.

Definition at line 2375 of file cow_string.h.

## ◆ capacity() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::capacity | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns the total number of characters that the string can hold before needing to allocate more memory.

Definition at line 1331 of file basic_string.h.

Referenced by std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::push_back(), reserve(), and reserve().

## ◆ capacity() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::capacity | ( |  | ) | const
| inlinenoexcept

Returns the total number of characters that the string can hold before needing to allocate more memory.

Definition at line 1059 of file cow_string.h.

## ◆ cbegin() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::cbegin | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns a read-only (constant) iterator that points to the first character in the string.

Definition at line 1178 of file basic_string.h.

## ◆ cbegin() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::cbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points to the first character in the string.

Definition at line 919 of file cow_string.h.

## ◆ cend() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::cend | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns a read-only (constant) iterator that points one past the last character in the string.

Definition at line 1187 of file basic_string.h.

## ◆ cend() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::cend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points one past the last character in the string.

Definition at line 927 of file cow_string.h.

## ◆ clear() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::clear | ( |  | ) |
| inlineconstexprnoexcept

Erases the string, making it empty.

Definition at line 1376 of file basic_string.h.

Referenced by std::__cxx11::collate< _CharT >::do_transform(), and std::basic_string< _CharT >::operator=().

## ◆ clear() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::clear | ( |  | ) |
| inlinenoexcept

Erases the string, making it empty.

Definition at line 1094 of file cow_string.h.

## ◆ compare() [1/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | const _CharT * | __s | ) | const
| inlinenodiscardconstexprnoexcept

Compare to a C string.

Parameters

  __s | C string to compare against.

Returns
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before __s, 0 if their values are equivalent, or > 0 if this string is ordered after __s. Determines the effective length rlen of the strings to compare as the smallest of size() and the length of a string constructed from __s. The function then compares the two strings by calling traits::compare(data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3709 of file basic_string.h.

## ◆ compare() [2/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | const _CharT * | __s | ) | const
| inlinenoexcept

Compare to a C string.

Parameters

  __s | C string to compare against.

Returns
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before __s, 0 if their values are equivalent, or > 0 if this string is ordered after __s. Determines the effective length rlen of the strings to compare as the smallest of size() and the length of a string constructed from __s. The function then compares the two strings by calling traits::compare(data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3112 of file cow_string.h.

## ◆ compare() [3/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) | const
| inlinenodiscardconstexpr

Compare to a string.

Parameters

  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before __str, 0 if their values are equivalent, or > 0 if this string is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of size() and str.size(). The function then compares the two strings by calling traits::compare(data(), str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3546 of file basic_string.h.

## ◆ compare() [4/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) | const
| inline

Compare to a string.

Parameters

  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before __str, 0 if their values are equivalent, or > 0 if this string is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of size() and str.size(). The function then compares the two strings by calling traits::compare(data(), str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 2955 of file cow_string.h.

## ◆ compare() [5/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str ) const
| inlinenodiscardconstexpr

Compare substring to a string.

Parameters

  __pos | Index of first character of substring.
  __n | Number of characters in substring.
  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n characters starting at __pos. Returns an integer < 0 if the substring is ordered before __str, 0 if their values are equivalent, or > 0 if the substring is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __str.size(). The function then compares the two strings by calling traits::compare(substring.data(),str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3641 of file basic_string.h.

## ◆ compare() [6/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str ) const
| inline

Compare substring to a string.

Parameters

  __pos | Index of first character of substring.
  __n | Number of characters in substring.
  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n characters starting at __pos. Returns an integer < 0 if the substring is ordered before __str, 0 if their values are equivalent, or > 0 if the substring is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __str.size(). The function then compares the two strings by calling traits::compare(substring.data(),str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3046 of file cow_string.h.

## ◆ compare() [7/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s ) const
| inlinenodiscardconstexpr

Compare substring to a C string.

Parameters

  __pos | Index of first character of substring.
  __n1 | Number of characters in substring.
  __s | C string to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at pos. Returns an integer < 0 if the substring is ordered before __s, 0 if their values are equivalent, or > 0 if the substring is ordered after __s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and the length of a string constructed from __s. The function then compares the two string by calling traits::compare(substring.data(),__s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3744 of file basic_string.h.

## ◆ compare() [8/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s ) const
| inline

Compare substring to a C string.

Parameters

  __pos | Index of first character of substring.
  __n1 | Number of characters in substring.
  __s | C string to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at pos. Returns an integer < 0 if the substring is ordered before __s, 0 if their values are equivalent, or > 0 if the substring is ordered after __s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and the length of a string constructed from __s. The function then compares the two string by calling traits::compare(substring.data(),__s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3146 of file cow_string.h.

## ◆ compare() [9/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 ) const
| inlinenodiscardconstexpr

Compare substring against a character array.

Parameters

  __pos | Index of first character of substring.
  __n1 | Number of characters in substring.
  __s | character array to compare against.
  __n2 | Number of characters of s.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos. Form a string from the first __n2 characters of __s. Returns an integer < 0 if this substring is ordered before the string from __s, 0 if their values are equivalent, or > 0 if this substring is ordered after the string from __s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __n2. The function then compares the two strings by calling traits::compare(substring.data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

NB: s must have at least n2 characters, '\0' has no special meaning.

Definition at line 3783 of file basic_string.h.

## ◆ compare() [10/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 ) const
| inline

Compare substring against a character array.

Parameters

  __pos | Index of first character of substring.
  __n1 | Number of characters in substring.
  __s | character array to compare against.
  __n2 | Number of characters of s.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos. Form a string from the first __n2 characters of __s. Returns an integer < 0 if this substring is ordered before the string from __s, 0 if their values are equivalent, or > 0 if this substring is ordered after the string from __s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __n2. The function then compares the two strings by calling traits::compare(substring.data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

NB: s must have at least n2 characters, '\0' has no special meaning.

Definition at line 3184 of file cow_string.h.

## ◆ compare() [11/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = npos ) const
| inlinenodiscardconstexpr

Compare substring to a substring.

Parameters

  __pos1 | Index of first character of substring.
  __n1 | Number of characters in substring.
  __str | String to compare against.
  __pos2 | Index of first character of substring of str.
  __n2 | Number of characters in substring of str.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos1. Form the substring of __str from the __n2 characters starting at __pos2. Returns an integer < 0 if this substring is ordered before the substring of __str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of __str. Determines the effective length rlen of the strings to compare as the smallest of the lengths of the substrings. The function then compares the two strings by calling traits::compare(substring.data(),str.substr(pos2,n2).data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3678 of file basic_string.h.

## ◆ compare() [12/12]

template<typename _CharT, typename _Traits, typename _Alloc>

int std::basic_string< _CharT, _Traits, _Alloc >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = npos ) const
| inline

Compare substring to a substring.

Parameters

  __pos1 | Index of first character of substring.
  __n1 | Number of characters in substring.
  __str | String to compare against.
  __pos2 | Index of first character of substring of str.
  __n2 | Number of characters in substring of str.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos1. Form the substring of __str from the __n2 characters starting at __pos2. Returns an integer < 0 if this substring is ordered before the substring of __str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of __str. Determines the effective length rlen of the strings to compare as the smallest of the lengths of the substrings. The function then compares the two strings by calling traits::compare(substring.data(),str.substr(pos2,n2).data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 3082 of file cow_string.h.

## ◆ contains() [1/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::contains | ( | _CharT | __x | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 3836 of file basic_string.h.

## ◆ contains() [2/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::contains | ( | _CharT | __x | ) | const
| inlinenoexcept

Definition at line 3231 of file cow_string.h.

## ◆ contains() [3/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::contains | ( | basic_string_view< _CharT, _Traits > | __x | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 3831 of file basic_string.h.

## ◆ contains() [4/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::contains | ( | basic_string_view< _CharT, _Traits > | __x | ) | const
| inlinenoexcept

Definition at line 3227 of file cow_string.h.

## ◆ contains() [5/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::contains | ( | const _CharT * | __x | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 3841 of file basic_string.h.

## ◆ contains() [6/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::contains | ( | const _CharT * | __x | ) | const
| inlinenoexcept

Definition at line 3236 of file cow_string.h.

## ◆ copy() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::copy | ( | _CharT * | __s,
|  | size_type | __n,
|  | size_type | __pos = 0 ) const
| constexpr

Copy substring into C string.

Parameters

  __s | C string to copy value into.
  __n | Number of characters to copy.
  __pos | Index of first character to copy.

Returns
  Number of characters actually copied

Exceptions

  std::out_of_range | If __pos > size().

Copies up to __n characters starting at __pos into the C string __s. If __pos is greater than size(), out_of_range is thrown.

Definition at line 3891 of file cow_string.h.

## ◆ copy() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::copy | ( | _CharT * | __s,
|  | size_type | __n,
|  | size_type | __pos = 0 ) const

Copy substring into C string.

Parameters

  __s | C string to copy value into.
  __n | Number of characters to copy.
  __pos | Index of first character to copy.

Returns
  Number of characters actually copied

Exceptions

  std::out_of_range | If __pos > size().

Copies up to __n characters starting at __pos into the C string __s. If __pos is greater than size(), out_of_range is thrown.

## ◆ crbegin() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::crbegin | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns a read-only (constant) reverse iterator that points to the last character in the string. Iteration is done in reverse element order.

Definition at line 1197 of file basic_string.h.

## ◆ crbegin() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::crbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last character in the string. Iteration is done in reverse element order.

Definition at line 936 of file cow_string.h.

## ◆ crend() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::crend | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns a read-only (constant) reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order.

Definition at line 1207 of file basic_string.h.

## ◆ crend() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::crend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order.

Definition at line 945 of file cow_string.h.

## ◆ data() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const _CharT * std::basic_string< _CharT, _Traits, _Alloc >::data | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Return const pointer to contents.

This is a pointer to internal data. It is undefined to modify the contents through the returned pointer. To get a pointer that allows modifying the contents use `&str`[0] instead, (or in C++17 the non-const `str.data()` overload).

Definition at line 2940 of file basic_string.h.

Referenced by std::basic_regex< char >::assign(), std::basic_string< _CharT >::compare(), std::basic_string< _CharT >::compare(), std::basic_string< _CharT >::compare(), std::__cxx11::collate< _CharT >::do_compare(), std::__cxx11::collate< _CharT >::do_transform(), std::basic_string< _CharT >::find(), std::basic_string< _CharT >::find_first_not_of(), std::basic_string< _CharT >::find_first_of(), std::basic_string< _CharT >::find_last_of(), std::match_results< _BidirectionalIterator, polymorphic_allocator< sub_match< _BidirectionalIterator > > >< const char * >::format(), std::wstring_convert< _Codecvt, _Elem, _Wide_alloc, _Byte_alloc >::from_bytes(), std::operator==(), std::basic_stringbuf< char >::str(), std::wstring_convert< _Codecvt, _Elem, _Wide_alloc, _Byte_alloc >::to_bytes(), and std::regex_traits< _CharT >::transform().

## ◆ data() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const _CharT * std::basic_string< _CharT, _Traits, _Alloc >::data | ( |  | ) | const
| inlinenoexcept

Return const pointer to contents.

This is a pointer to internal data. It is undefined to modify the contents through the returned pointer. To get a pointer that allows modifying the contents use `&str`[0] instead, (or in C++17 the non-const `str.data()` overload).

Definition at line 2387 of file cow_string.h.

## ◆ data() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

_CharT * std::basic_string< _CharT, _Traits, _Alloc >::data | ( |  | ) |
| inlinenodiscardconstexprnoexcept

Return non-const pointer to contents.

This is a pointer to the character sequence held by the string. Modifying the characters in the sequence is allowed.

Definition at line 2952 of file basic_string.h.

## ◆ data() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

_CharT * std::basic_string< _CharT, _Traits, _Alloc >::data | ( |  | ) |
| inline

Return non-const pointer to contents.

This is a pointer to the character sequence held by the string. Modifying the characters in the sequence is allowed.

The standard requires this function to be noexcept but for the Copy-On-Write string implementation it can throw. This function allows modifying the string contents directly, which means we must copy-on-write to unshare it, which requires allocating memory.

Definition at line 2403 of file cow_string.h.

## ◆ empty() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::empty | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns true if the string is empty. Equivalent to `*this == ""`.

Definition at line 1385 of file basic_string.h.

Referenced by std::basic_string< _CharT >::back(), std::basic_string< _CharT >::back(), std::basic_string< _CharT >::back(), std::basic_string< _CharT >::front(), std::basic_string< _CharT >::front(), std::basic_string< _CharT >::front(), std::regex_traits< _Ch_type >::lookup_collatename(), std::tr2::operator>>(), std::basic_string< _CharT >::pop_back(), and std::basic_string< _CharT >::pop_back().

## ◆ empty() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::empty | ( |  | ) | const
| inlinenodiscardnoexcept

Returns true if the string is empty. Equivalent to `*this == ""`.

Definition at line 1116 of file cow_string.h.

## ◆ end() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::end | ( |  | ) |
| inline

Returns a read/write iterator that points one past the last character in the string. Unshares the string.

Definition at line 863 of file cow_string.h.

## ◆ end() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::end | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns a read-only (constant) iterator that points one past the last character in the string.

Definition at line 1128 of file basic_string.h.

## ◆ end() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_iterator std::basic_string< _CharT, _Traits, _Alloc >::end | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) iterator that points one past the last character in the string.

Definition at line 874 of file cow_string.h.

## ◆ end() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::end | ( |  | ) |
| inlinenodiscardconstexprnoexcept

Returns a read/write iterator that points one past the last character in the string.

Definition at line 1119 of file basic_string.h.

Referenced by std::basic_string< _CharT >::append(), std::basic_string< _CharT >::crbegin(), std::basic_string< _CharT >::erase(), std::basic_string< _CharT >::erase(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::rbegin(), std::basic_string< _CharT >::rbegin(), std::basic_string< _CharT >::rbegin(), std::regex_match(), std::regex_match(), std::regex_replace(), std::regex_replace(), std::regex_search(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), and std::basic_string< _CharT >::replace().

## ◆ ends_with() [1/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | _CharT | __x | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 3819 of file basic_string.h.

## ◆ ends_with() [2/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | _CharT | __x | ) | const
| inlinenoexcept

Definition at line 3216 of file cow_string.h.

## ◆ ends_with() [3/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | basic_string_view< _CharT, _Traits > | __x | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 3814 of file basic_string.h.

## ◆ ends_with() [4/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | basic_string_view< _CharT, _Traits > | __x | ) | const
| inlinenoexcept

Definition at line 3212 of file cow_string.h.

## ◆ ends_with() [5/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | const _CharT * | __x | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 3824 of file basic_string.h.

## ◆ ends_with() [6/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::ends_with | ( | const _CharT * | __x | ) | const
| inlinenoexcept

Definition at line 3221 of file cow_string.h.

## ◆ erase() [1/6]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | __const_iterator | __first,
|  | __const_iterator | __last )
| inlineconstexpr

Remove a range of characters.

Parameters

  __first | Iterator referencing the first character to remove.
  __last | Iterator referencing the end of the range.

Returns
  Iterator referencing location of first after removal.

Removes the characters in the range [first,last) from this string. The value of the string doesn't change if an error is thrown.

Definition at line 2417 of file basic_string.h.

## ◆ erase() [2/6]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | __const_iterator | __position | ) |
| inlineconstexpr

Remove one character.

Parameters

  __position | Iterator referencing the character to remove.

Returns
  iterator referencing same location after removal.

Removes the character at __position from this string. The value of the string doesn't change if an error is thrown.

Definition at line 2397 of file basic_string.h.

## ◆ erase() [3/6]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::iterator std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | iterator | __first,
|  | iterator | __last )

Remove a range of characters.

Parameters

  __first | Iterator referencing the first character to remove.
  __last | Iterator referencing the end of the range.

Returns
  Iterator referencing location of first after removal.

Removes the characters in the range [first,last) from this string. The value of the string doesn't change if an error is thrown.

Definition at line 3554 of file cow_string.h.

## ◆ erase() [4/6]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | iterator | __position | ) |
| inline

Remove one character.

Parameters

  __position | Iterator referencing the character to remove.

Returns
  iterator referencing same location after removal.

Removes the character at __position from this string. The value of the string doesn't change if an error is thrown.

Definition at line 1874 of file cow_string.h.

## ◆ erase() [5/6]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | size_type | __pos = 0,
|  | size_type | __n = npos )
| inlineconstexpr

Remove characters.

Parameters

  __pos | Index of first character to remove (default 0).
  __n | Number of characters to remove (default remainder).

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos is beyond the end of this string.

Removes __n characters from this string starting at __pos. The length of the string is reduced by __n. If there are < __n characters to remove, the remainder of the string is truncated. If __p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2377 of file basic_string.h.

Referenced by std::getline(), std::operator>>(), std::basic_string< _CharT >::pop_back(), and resize().

## ◆ erase() [6/6]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::erase | ( | size_type | __pos = 0,
|  | size_type | __n = npos )
| inline

Remove characters.

Parameters

  __pos | Index of first character to remove (default 0).
  __n | Number of characters to remove (default remainder).

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos is beyond the end of this string.

Removes __n characters from this string starting at __pos. The length of the string is reduced by __n. If there are < __n characters to remove, the remainder of the string is truncated. If __p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1858 of file cow_string.h.

## ◆ find() [1/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const
| nodiscardconstexprnoexcept

Find position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 738 of file basic_string.tcc.

References npos, and std::size().

## ◆ find() [2/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const
| noexcept

Find position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

## ◆ find() [3/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| nodiscardconstexprnoexcept

Find position of a C substring.

Parameters

  __s | C string to locate.
  __pos | Index of character to search from.
  __n | Number of characters from s to search for.

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for the first __n characters in __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 701 of file basic_string.tcc.

References std::data(), npos, and std::size().

Referenced by std::basic_string< _CharT >::find(), std::basic_string< _CharT >::find(), std::basic_string< _CharT >::find(), and std::basic_string< _CharT >::find_first_of().

## ◆ find() [4/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| noexcept

Find position of a C substring.

Parameters

  __s | C string to locate.
  __pos | Index of character to search from.
  __n | Number of characters from s to search for.

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for the first __n characters in __s within this string. If found, returns the index where it begins. If not found, returns npos.

## ◆ find() [5/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const
| inlinenodiscardconstexprnoexcept

Find position of a C string.

Parameters

  __s | C string to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for the value of __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 3027 of file basic_string.h.

## ◆ find() [6/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const
| inlinenoexcept

Find position of a C string.

Parameters

  __s | C string to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for the value of __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2459 of file cow_string.h.

## ◆ find() [7/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = 0 ) const
| inlinenodiscardconstexprnoexcept

Find position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2993 of file basic_string.h.

## ◆ find() [8/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = 0 ) const
| inlinenoexcept

Find position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2444 of file cow_string.h.

## ◆ find_first_not_of() [1/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const
| nodiscardconstexprnoexcept

Find position of a different character.

Parameters

  __c | Character to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character other than __c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 852 of file basic_string.tcc.

References npos, and std::size().

## ◆ find_first_not_of() [2/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const
| noexcept

Find position of a different character.

Parameters

  __c | Character to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character other than __c within this string. If found, returns the index where it was found. If not found, returns npos.

## ◆ find_first_not_of() [3/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| nodiscardconstexprnoexcept

Find position of a character not in C substring.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search from.
  __n | Number of characters from __s to consider.

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 838 of file basic_string.tcc.

References npos, and std::size().

## ◆ find_first_not_of() [4/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| noexcept

Find position of a character not in C substring.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search from.
  __n | Number of characters from __s to consider.

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## ◆ find_first_not_of() [5/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const
| inlinenodiscardconstexprnoexcept

Find position of a character not in C string.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3372 of file basic_string.h.

## ◆ find_first_not_of() [6/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const
| inlinenoexcept

Find position of a character not in C string.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2783 of file cow_string.h.

## ◆ find_first_not_of() [7/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = 0 ) const
| inlinenodiscardconstexprnoexcept

Find position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3320 of file basic_string.h.

Referenced by std::basic_string< _CharT >::find_first_not_of(), std::basic_string< _CharT >::find_first_not_of(), and std::basic_string< _CharT >::find_first_not_of().

## ◆ find_first_not_of() [8/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_not_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = 0 ) const
| inlinenoexcept

Find position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2752 of file cow_string.h.

## ◆ find_first_of() [1/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const
| inlinenodiscardconstexprnoexcept

Find position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for the character __c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to find(__c, __pos).

Definition at line 3216 of file basic_string.h.

## ◆ find_first_of() [2/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const
| inlinenoexcept

Find position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for the character __c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to find(__c, __pos).

Definition at line 2636 of file cow_string.h.

## ◆ find_first_of() [3/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| nodiscardconstexprnoexcept

Find position of a character of C substring.

Parameters

  __s | String containing characters to locate.
  __pos | Index of character to search from.
  __n | Number of characters from s to search for.

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 798 of file basic_string.tcc.

References npos, and std::size().

## ◆ find_first_of() [4/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| noexcept

Find position of a character of C substring.

Parameters

  __s | String containing characters to locate.
  __pos | Index of character to search from.
  __n | Number of characters from s to search for.

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## ◆ find_first_of() [5/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const
| inlinenodiscardconstexprnoexcept

Find position of a character of C string.

Parameters

  __s | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3195 of file basic_string.h.

## ◆ find_first_of() [6/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const
| inlinenoexcept

Find position of a character of C string.

Parameters

  __s | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2616 of file cow_string.h.

## ◆ find_first_of() [7/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = 0 ) const
| inlinenodiscardconstexprnoexcept

Find position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3143 of file basic_string.h.

Referenced by std::basic_string< _CharT >::find_first_of(), and std::basic_string< _CharT >::find_first_of().

## ◆ find_first_of() [8/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_first_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = 0 ) const
| inlinenoexcept

Find position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2585 of file cow_string.h.

## ◆ find_last_not_of() [1/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | _CharT | __c,
|  | size_type | __pos = npos ) const
| nodiscardconstexprnoexcept

Find last position of a different character.

Parameters

  __c | Character to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character other than __c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 887 of file basic_string.tcc.

References npos, and std::size().

## ◆ find_last_not_of() [2/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | _CharT | __c,
|  | size_type | __pos = npos ) const
| noexcept

Find last position of a different character.

Parameters

  __c | Character to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character other than __c within this string. If found, returns the index where it was found. If not found, returns npos.

## ◆ find_last_not_of() [3/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| nodiscardconstexprnoexcept

Find last position of a character not in C substring.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search back from.
  __n | Number of characters from s to consider.

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 864 of file basic_string.tcc.

References npos, and std::size().

## ◆ find_last_not_of() [4/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| noexcept

Find last position of a character not in C substring.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search back from.
  __n | Number of characters from s to consider.

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## ◆ find_last_not_of() [5/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const
| inlinenodiscardconstexprnoexcept

Find last position of a character not in C string.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3459 of file basic_string.h.

## ◆ find_last_not_of() [6/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const
| inlinenoexcept

Find last position of a character not in C string.

Parameters

  __s | C string containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2865 of file cow_string.h.

## ◆ find_last_not_of() [7/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = npos ) const
| inlinenodiscardconstexprnoexcept

Find last position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3407 of file basic_string.h.

Referenced by std::basic_string< _CharT >::find_last_not_of(), std::basic_string< _CharT >::find_last_not_of(), and std::basic_string< _CharT >::find_last_not_of().

## ◆ find_last_not_of() [8/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_not_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = npos ) const
| inlinenoexcept

Find last position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2834 of file cow_string.h.

## ◆ find_last_of() [1/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | _CharT | __c,
|  | size_type | __pos = npos ) const
| inlinenodiscardconstexprnoexcept

Find last position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to rfind(__c, __pos).

Definition at line 3305 of file basic_string.h.

## ◆ find_last_of() [2/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | _CharT | __c,
|  | size_type | __pos = npos ) const
| inlinenoexcept

Find last position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to rfind(__c, __pos).

Definition at line 2720 of file cow_string.h.

## ◆ find_last_of() [3/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| nodiscardconstexprnoexcept

Find last position of a character of C substring.

Parameters

  __s | C string containing characters to locate.
  __pos | Index of character to search back from.
  __n | Number of characters from s to search for.

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 815 of file basic_string.tcc.

References npos, and std::size().

## ◆ find_last_of() [4/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| noexcept

Find last position of a character of C substring.

Parameters

  __s | C string containing characters to locate.
  __pos | Index of character to search back from.
  __n | Number of characters from s to search for.

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the first __n characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

## ◆ find_last_of() [5/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const
| inlinenodiscardconstexprnoexcept

Find last position of a character of C string.

Parameters

  __s | C string containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3284 of file basic_string.h.

## ◆ find_last_of() [6/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const
| inlinenoexcept

Find last position of a character of C string.

Parameters

  __s | C string containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2700 of file cow_string.h.

## ◆ find_last_of() [7/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = npos ) const
| inlinenodiscardconstexprnoexcept

Find last position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 3232 of file basic_string.h.

Referenced by std::basic_string< _CharT >::find_last_of(), and std::basic_string< _CharT >::find_last_of().

## ◆ find_last_of() [8/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::find_last_of | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = npos ) const
| inlinenoexcept

Find last position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2669 of file cow_string.h.

## ◆ front() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::front | ( |  | ) |
| inline

Returns a read/write reference to the data at the first element of the string.

Definition at line 1209 of file cow_string.h.

## ◆ front() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::front | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns a read-only (constant) reference to the data at the first element of the string.

Definition at line 1492 of file basic_string.h.

## ◆ front() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::front | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reference to the data at the first element of the string.

Definition at line 1220 of file cow_string.h.

## ◆ front() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::front | ( |  | ) |
| inlinenodiscardconstexprnoexcept

Returns a read/write reference to the data at the first element of the string.

Definition at line 1480 of file basic_string.h.

## ◆ get_allocator() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

allocator_type std::basic_string< _CharT, _Traits, _Alloc >::get_allocator | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Return copy of allocator used to construct this string.

Definition at line 2961 of file basic_string.h.

Referenced by std::basic_string< _CharT >::~basic_string(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::clear(), std::operator+(), std::operator+(), std::operator+(), std::operator+(), std::operator+(), reserve(), reserve(), std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > >::reserve(), and swap().

## ◆ get_allocator() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

allocator_type std::basic_string< _CharT, _Traits, _Alloc >::get_allocator | ( |  | ) | const
| inlinenoexcept

Return copy of allocator used to construct this string.

Definition at line 2414 of file cow_string.h.

## ◆ insert() [1/18]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | __const_iterator | __p,
|  | _CharT | __c )
| inlineconstexpr

Insert one character.

Parameters

  __p | Iterator referencing position in string to insert at.
  __c | The character to insert.

Returns
  Iterator referencing newly inserted char.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts character __c at position referenced by __p. If adding character causes the length to exceed max_size(), length_error is thrown. If __p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2314 of file basic_string.h.

## ◆ insert() [2/18]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

iterator std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | const_iterator | __p,
|  | _InputIterator | __beg,
|  | _InputIterator | __end )
| inlineconstexpr

Insert a range of characters.

Parameters

  __p | Const_iterator referencing location in string to insert at.
  __beg | Start of range.
  __end | End of range.

Returns
  Iterator referencing the first inserted char.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts characters in range [beg,end). If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2108 of file basic_string.h.

## ◆ insert() [3/18]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | const_iterator | __p,
|  | initializer_list< _CharT > | __l )
| inlineconstexpr

Insert an initializer_list of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __l | The initializer_list of characters to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Definition at line 2174 of file basic_string.h.

## ◆ insert() [4/18]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | const_iterator | __p,
|  | size_type | __n,
|  | _CharT | __c )
| inlineconstexpr

Insert multiple characters.

Parameters

  __p | Const_iterator referencing location in string to insert at.
  __n | Number of characters to insert
  __c | The character to insert.

Returns
  Iterator referencing the first inserted char.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts __n copies of character __c starting at the position referenced by iterator __p. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2063 of file basic_string.h.

Referenced by std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), and std::basic_string< _CharT >::insert().

## ◆ insert() [5/18]

template<typename _CharT, typename _Traits, typename _Alloc>

iterator std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | _CharT | __c )
| inline

Insert one character.

Parameters

  __p | Iterator referencing position in string to insert at.
  __c | The character to insert.

Returns
  Iterator referencing newly inserted char.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts character __c at position referenced by __p. If adding character causes the length to exceed max_size(), length_error is thrown. If __p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1798 of file cow_string.h.

## ◆ insert() [6/18]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator>

void std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | _InputIterator | __beg,
|  | _InputIterator | __end )
| inline

Insert a range of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __beg | Start of range.
  __end | End of range.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts characters in range [__beg,__end). If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1636 of file cow_string.h.

## ◆ insert() [7/18]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | initializer_list< _CharT > | __l )
| inline

Insert an initializer_list of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __l | The initializer_list of characters to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Definition at line 1674 of file cow_string.h.

## ◆ insert() [8/18]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | iterator | __p,
|  | size_type | __n,
|  | _CharT | __c )
| inline

Insert multiple characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __n | Number of characters to insert
  __c | The character to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts __n copies of character __c starting at the position referenced by iterator __p. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1619 of file cow_string.h.

## ◆ insert() [9/18]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | const _CharT * | __s )
| inlineconstexpr

Insert a C string.

Parameters

  __pos | Position in string to insert at.
  __s | The C string to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If pos is beyond the end of this string.

Inserts the first n characters of __s starting at __pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2270 of file basic_string.h.

## ◆ insert() [10/18]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | const _CharT * | __s )
| inline

Insert a C string.

Parameters

  __pos | Position in string to insert at.
  __s | The C string to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If pos is beyond the end of this string.

Inserts the first n characters of __s starting at __pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1757 of file cow_string.h.

## ◆ insert() [11/18]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | const _CharT * | __s,
|  | size_type | __n )
| inlineconstexpr

Insert a C substring.

Parameters

  __pos | Position in string to insert at.
  __s | The C string to insert.
  __n | The number of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If __pos is beyond the end of this string.

Inserts the first __n characters of __s starting at __pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2250 of file basic_string.h.

## ◆ insert() [12/18]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | const _CharT * | __s,
|  | size_type | __n )

Insert a C substring.

Parameters

  __pos | Position in string to insert at.
  __s | The C string to insert.
  __n | The number of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If __pos is beyond the end of this string.

Inserts the first __n characters of __s starting at __pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

## ◆ insert() [13/18]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | size_type | __n,
|  | _CharT | __c )
| inlineconstexpr

Insert multiple characters.

Parameters

  __pos | Index in string to insert at.
  __n | Number of characters to insert
  __c | The character to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If __pos is beyond the end of this string.

Inserts __n copies of character __c starting at index __pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos > length(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2295 of file basic_string.h.

## ◆ insert() [14/18]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos,
|  | size_type | __n,
|  | _CharT | __c )
| inline

Insert multiple characters.

Parameters

  __pos | Index in string to insert at.
  __n | Number of characters to insert
  __c | The character to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If __pos is beyond the end of this string.

Inserts __n copies of character __c starting at index __pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos > length(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1780 of file cow_string.h.

## ◆ insert() [15/18]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str )
| inlineconstexpr

Insert value of a string.

Parameters

  __pos1 | Position in string to insert at.
  __str | The string to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts value of __str starting at __pos1. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2202 of file basic_string.h.

## ◆ insert() [16/18]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str )
| inline

Insert value of a string.

Parameters

  __pos1 | Position in string to insert at.
  __str | The string to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts value of __str starting at __pos1. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1694 of file cow_string.h.

## ◆ insert() [17/18]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n = npos )
| inlineconstexpr

Insert a substring.

Parameters

  __pos1 | Position in string to insert at.
  __str | The string to insert.
  __pos2 | Start of characters in str to insert.
  __n | Number of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If pos1 > size() or __pos2 > str.size().

Starting at pos1, insert __n character of __str beginning with __pos2. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos1 is beyond the end of this string or __pos2 is beyond the end of __str, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2226 of file basic_string.h.

## ◆ insert() [18/18]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n = npos )
| inline

Insert a substring.

Parameters

  __pos1 | Position in string to insert at.
  __str | The string to insert.
  __pos2 | Start of characters in str to insert.
  __n | Number of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If pos1 > size() or __pos2 > str.size().

Starting at pos1, insert __n character of __str beginning with __pos2. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos1 is beyond the end of this string or __pos2 is beyond the end of __str, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1716 of file cow_string.h.

## ◆ length() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::length | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns the number of characters in the string, not including any null-termination.

Definition at line 1229 of file basic_string.h.

Referenced by std::basic_string< _CharT >::basic_string(), std::basic_string< _CharT >::basic_string(), std::__cxx11::collate< _CharT >::do_compare(), std::__cxx11::collate< _CharT >::do_transform(), std::basic_string< _CharT >::operator=(), std::regex_replace(), and reserve().

## ◆ length() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::length | ( |  | ) | const
| inlinenoexcept

Returns the number of characters in the string, not including any null-termination.

Definition at line 967 of file cow_string.h.

## ◆ max_size() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::max_size | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns the size() of the largest possible string.

Definition at line 1235 of file basic_string.h.

Referenced by std::getline(), and std::operator>>().

## ◆ max_size() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::max_size | ( |  | ) | const
| inlinenoexcept

Returns the size() of the largest possible string.

Definition at line 972 of file cow_string.h.

## ◆ operator+=() [1/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | _CharT | __c | ) |
| inlineconstexpr

Append a character.

Parameters

  __c | The character to append.

Returns
  Reference to this string.

Definition at line 1551 of file basic_string.h.

## ◆ operator+=() [2/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | _CharT | __c | ) |
| inline

Append a character.

Parameters

  __c | The character to append.

Returns
  Reference to this string.

Definition at line 1274 of file cow_string.h.

## ◆ operator+=() [3/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | const _CharT * | __s | ) |
| inlineconstexpr

Append a C string.

Parameters

  __s | The C string to append.

Returns
  Reference to this string.

Definition at line 1541 of file basic_string.h.

## ◆ operator+=() [4/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | const _CharT * | __s | ) |
| inline

Append a C string.

Parameters

  __s | The C string to append.

Returns
  Reference to this string.

Definition at line 1265 of file cow_string.h.

## ◆ operator+=() [5/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |
| inlineconstexpr

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

Definition at line 1531 of file basic_string.h.

## ◆ operator+=() [6/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |
| inline

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

Definition at line 1256 of file cow_string.h.

## ◆ operator+=() [7/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | initializer_list< _CharT > | __l | ) |
| inlineconstexpr

Append an initializer_list of characters.

Parameters

  __l | The initializer_list of characters to be appended.

Returns
  Reference to this string.

Definition at line 1565 of file basic_string.h.

## ◆ operator+=() [8/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator+= | ( | initializer_list< _CharT > | __l | ) |
| inline

Append an initializer_list of characters.

Parameters

  __l | The initializer_list of characters to be appended.

Returns
  Reference to this string.

Definition at line 1287 of file cow_string.h.

## ◆ operator=() [1/10]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | _CharT | __c | ) |
| inlineconstexpr

Set value to string of length 1.

Parameters

  __c | Source character.

Assigning to a character makes this string length 1 and (*this)[0] == c.

Definition at line 981 of file basic_string.h.

## ◆ operator=() [2/10]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | _CharT | __c | ) |
| inline

Set value to string of length 1.

Parameters

  __c | Source character.

Assigning to a character makes this string length 1 and (*this)[0] == c.

Definition at line 785 of file cow_string.h.

## ◆ operator=() [3/10]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | basic_string< _CharT, _Traits, _Alloc > && | __str | ) |
| inlinenoexcept

Move assign the value of str to this string.

Parameters

  __str | Source string.

The contents of str are moved into this string (without copying). str is a valid, but unspecified string.

Definition at line 800 of file cow_string.h.

## ◆ operator=() [4/10]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | basic_string< _CharT, _Traits, _Alloc > && | __str | ) |
| inlineconstexprnoexcept

Move assign the value of str to this string.

Parameters

  __str | Source string.

The contents of str are moved into this string (without copying). str is a valid, but unspecified string.

Definition at line 999 of file basic_string.h.

## ◆ operator=() [5/10]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | const _CharT * | __s | ) |
| inlineconstexpr

Copy contents of s into this string.

Parameters

  __s | Source null-terminated string.

Definition at line 969 of file basic_string.h.

## ◆ operator=() [6/10]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | const _CharT * | __s | ) |
| inline

Copy contents of s into this string.

Parameters

  __s | Source null-terminated string.

Definition at line 774 of file cow_string.h.

## ◆ operator=() [7/10]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |
| inlineconstexpr

Assign the value of str to this string.

Parameters

  __str | Source string.

Definition at line 958 of file basic_string.h.

## ◆ operator=() [8/10]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str | ) |
| inline

Assign the value of str to this string.

Parameters

  __str | Source string.

Definition at line 766 of file cow_string.h.

## ◆ operator=() [9/10]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | initializer_list< _CharT > | __l | ) |
| inlineconstexpr

Set value to string constructed from initializer list.

Parameters

  __l | std::initializer_list.

Definition at line 1067 of file basic_string.h.

## ◆ operator=() [10/10]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::operator= | ( | initializer_list< _CharT > | __l | ) |
| inline

Set value to string constructed from initializer list.

Parameters

  __l | std::initializer_list.

Definition at line 813 of file cow_string.h.

## ◆ operator[]() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::operator[] | ( | size_type | __pos | ) |
| inlinenodiscardconstexpr

Subscript access to the data contained in the string.

Parameters

  __pos | The index of the character to access.

Returns
  Read/write reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 1419 of file basic_string.h.

## ◆ operator[]() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reference std::basic_string< _CharT, _Traits, _Alloc >::operator[] | ( | size_type | __pos | ) |
| inline

Subscript access to the data contained in the string.

Parameters

  __pos | The index of the character to access.

Returns
  Read/write reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().) Unshares the string.

Definition at line 1148 of file cow_string.h.

## ◆ operator[]() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::operator[] | ( | size_type | __pos | ) | const
| inlinenodiscardconstexprnoexcept

Subscript access to the data contained in the string.

Parameters

  __pos | The index of the character to access.

Returns
  Read-only (constant) reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 1401 of file basic_string.h.

Referenced by std::basic_string< _CharT >::back(), std::basic_string< _CharT >::back(), std::basic_string< _CharT >::back(), std::basic_string< _CharT >::front(), std::basic_string< _CharT >::front(), and std::basic_string< _CharT >::front().

## ◆ operator[]() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::operator[] | ( | size_type | __pos | ) | const
| inlinenoexcept

Subscript access to the data contained in the string.

Parameters

  __pos | The index of the character to access.

Returns
  Read-only (constant) reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 1131 of file cow_string.h.

## ◆ pop_back() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::pop_back | ( |  | ) |
| inline

Remove the last character.

The string must be non-empty.

Definition at line 1903 of file cow_string.h.

## ◆ pop_back() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::pop_back | ( |  | ) |
| inlineconstexprnoexcept

Remove the last character.

The string must be non-empty.

Definition at line 2437 of file basic_string.h.

## ◆ push_back() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::push_back | ( | _CharT | __c | ) |
| inlineconstexpr

Append a single character.

Parameters

  __c | Character to append.

Definition at line 1778 of file basic_string.h.

Referenced by std::__cxx11::collate< _CharT >::do_transform(), std::basic_string< _CharT >::operator+=(), std::tr2::operator>>(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow().

## ◆ push_back() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::push_back | ( | _CharT | __c | ) |
| inline

Append a single character.

Parameters

  __c | Character to append.

Definition at line 1437 of file cow_string.h.

## ◆ rbegin() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rbegin | ( |  | ) |
| inline

Returns a read/write reverse iterator that points to the last character in the string. Iteration is done in reverse element order. Unshares the string.

Definition at line 883 of file cow_string.h.

## ◆ rbegin() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rbegin | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns a read-only (constant) reverse iterator that points to the last character in the string. Iteration is done in reverse element order.

Definition at line 1148 of file basic_string.h.

## ◆ rbegin() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rbegin | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to the last character in the string. Iteration is done in reverse element order.

Definition at line 892 of file cow_string.h.

## ◆ rbegin() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rbegin | ( |  | ) |
| inlinenodiscardconstexprnoexcept

Returns a read/write reverse iterator that points to the last character in the string. Iteration is done in reverse element order.

Definition at line 1138 of file basic_string.h.

## ◆ rend() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rend | ( |  | ) |
| inline

Returns a read/write reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order. Unshares the string.

Definition at line 901 of file cow_string.h.

## ◆ rend() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rend | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns a read-only (constant) reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order.

Definition at line 1168 of file basic_string.h.

## ◆ rend() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

const_reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rend | ( |  | ) | const
| inlinenoexcept

Returns a read-only (constant) reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order.

Definition at line 910 of file cow_string.h.

## ◆ rend() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

reverse_iterator std::basic_string< _CharT, _Traits, _Alloc >::rend | ( |  | ) |
| inlinenodiscardconstexprnoexcept

Returns a read/write reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order.

Definition at line 1158 of file basic_string.h.

## ◆ replace() [1/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | _CharT * | __k1,
|  | _CharT * | __k2 )
| inlineconstexpr

Definition at line 2707 of file basic_string.h.

## ◆ replace() [2/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const _CharT * | __k1,
|  | const _CharT * | __k2 )
| inlineconstexpr

Definition at line 2719 of file basic_string.h.

## ◆ replace() [3/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const _CharT * | __s )
| inlineconstexpr

Replace range of characters with C string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2626 of file basic_string.h.

## ◆ replace() [4/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const _CharT * | __s,
|  | size_type | __n )
| inlineconstexpr

Replace range of characters with C substring.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.
  __n | Number of characters from s to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the first __n characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2603 of file basic_string.h.

## ◆ replace() [5/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str )
| inlineconstexpr

Replace range of characters with string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __str | String value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the value of __str is inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2582 of file basic_string.h.

## ◆ replace() [6/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | const_iterator | __k1,
|  | const_iterator | __k2 )
| inlineconstexpr

Definition at line 2743 of file basic_string.h.

## ◆ replace() [7/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | iterator | __k1,
|  | iterator | __k2 )
| inlineconstexpr

Definition at line 2731 of file basic_string.h.

## ◆ replace() [8/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | __const_iterator | __i1,
|  | __const_iterator | __i2,
|  | size_type | __n,
|  | _CharT | __c )
| inlineconstexpr

Replace range of characters with multiple characters.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __n | Number of characters to insert.
  __c | Character to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, __n copies of __c are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2648 of file basic_string.h.

## ◆ replace() [9/30]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | const_iterator | __i1,
|  | const_iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2 )
| inlineconstexpr

Replace range of characters with range.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __k1 | Iterator referencing start of range to insert.
  __k2 | Iterator referencing end of range to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2676 of file basic_string.h.

## ◆ replace() [10/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | const_iterator | __i1,
|  | const_iterator | __i2,
|  | initializer_list< _CharT > | __l )
| inlineconstexpr

Replace range of characters with initializer_list.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __l | The initializer_list of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2793 of file basic_string.h.

## ◆ replace() [11/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | _CharT * | __k1,
|  | _CharT * | __k2 )
| inline

Definition at line 2134 of file cow_string.h.

## ◆ replace() [12/30]

template<typename _CharT, typename _Traits, typename _Alloc>
template<class _InputIterator>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2 )
| inline

Replace range of characters with range.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __k1 | Iterator referencing start of range to insert.
  __k2 | Iterator referencing end of range to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2122 of file cow_string.h.

## ◆ replace() [13/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __k1,
|  | const _CharT * | __k2 )
| inline

Definition at line 2144 of file cow_string.h.

## ◆ replace() [14/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s )
| inline

Replace range of characters with C string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2077 of file cow_string.h.

## ◆ replace() [15/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s,
|  | size_type | __n )
| inline

Replace range of characters with C substring.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.
  __n | Number of characters from s to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the first __n characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2056 of file cow_string.h.

## ◆ replace() [16/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str )
| inline

Replace range of characters with string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __str | String value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the value of __str is inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2037 of file cow_string.h.

## ◆ replace() [17/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const_iterator | __k1,
|  | const_iterator | __k2 )
| inline

Definition at line 2165 of file cow_string.h.

## ◆ replace() [18/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | initializer_list< _CharT > | __l )
| inline

Replace range of characters with initializer_list.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __l | The initializer_list of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2211 of file cow_string.h.

## ◆ replace() [19/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | iterator | __k1,
|  | iterator | __k2 )
| inline

Definition at line 2155 of file cow_string.h.

## ◆ replace() [20/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | size_type | __n,
|  | _CharT | __c )
| inline

Replace range of characters with multiple characters.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __n | Number of characters to insert.
  __c | Character to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, __n copies of __c are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2098 of file cow_string.h.

## ◆ replace() [21/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str )
| inlineconstexpr

Replace characters with value from another string.

Parameters

  __pos | Index of first character to replace.
  __n | Number of characters to be replaced.
  __str | String to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos is beyond the end of this string.
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos+__n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2463 of file basic_string.h.

Referenced by std::basic_string< _CharT >::append(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), and std::basic_string< _CharT >::replace().

## ◆ replace() [22/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str )
| inline

Replace characters with value from another string.

Parameters

  __pos | Index of first character to replace.
  __n | Number of characters to be replaced.
  __str | String to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos is beyond the end of this string.
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos+__n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1928 of file cow_string.h.

## ◆ replace() [23/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s )
| inlineconstexpr

Replace characters with value of a C string.

Parameters

  __pos | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __s | C string to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos > size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos + __n1) from this string. In place, the characters of __s are inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2538 of file basic_string.h.

## ◆ replace() [24/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s )
| inline

Replace characters with value of a C string.

Parameters

  __pos | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __s | C string to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos > size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos + __n1) from this string. In place, the characters of __s are inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1995 of file cow_string.h.

## ◆ replace() [25/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc > & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 )
| inlineconstexpr

Replace characters with value of a C substring.

Parameters

  __pos | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __s | C string to insert.
  __n2 | Number of characters from s to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos1 > size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos + __n1) from this string. In place, the first __n2 characters of __s are inserted, or all of __s if __n2 is too large. If __pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2512 of file basic_string.h.

## ◆ replace() [26/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 )

Replace characters with value of a C substring.

Parameters

  __pos | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __s | C string to insert.
  __n2 | Number of characters from s to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos1 > size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos + __n1) from this string. In place, the first __n2 characters of __s are inserted, or all of __s if __n2 is too large. If __pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

## ◆ replace() [27/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | size_type | __n2,
|  | _CharT | __c )
| inlineconstexpr

Replace characters with multiple characters.

Parameters

  __pos | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __n2 | Number of characters to insert.
  __c | Character to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If __pos > size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, __n2 copies of __c are inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2563 of file basic_string.h.

## ◆ replace() [28/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | size_type | __n2,
|  | _CharT | __c )
| inline

Replace characters with multiple characters.

Parameters

  __pos | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __n2 | Number of characters to insert.
  __c | Character to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If __pos > size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, __n2 copies of __c are inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2019 of file cow_string.h.

## ◆ replace() [29/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = npos )
| inlineconstexpr

Replace characters with value from another string.

Parameters

  __pos1 | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __str | String to insert.
  __pos2 | Index of first character of str to use.
  __n2 | Number of characters from str to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If __pos1 > size() or __pos2 > __str.size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos1,__pos1 + n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2486 of file basic_string.h.

## ◆ replace() [30/30]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string & std::basic_string< _CharT, _Traits, _Alloc >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = npos )
| inline

Replace characters with value from another string.

Parameters

  __pos1 | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __str | String to insert.
  __pos2 | Index of first character of str to use.
  __n2 | Number of characters from str to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If __pos1 > size() or __pos2 > __str.size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos1,__pos1 + n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1950 of file cow_string.h.

## ◆ reserve() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::reserve | ( |  | ) |
| constexpr

Equivalent to shrink_to_fit().

Definition at line 3870 of file cow_string.h.

References capacity(), get_allocator(), and length().

Referenced by std::basic_string< _CharT >::push_back(), and std::basic_string< _CharT >::shrink_to_fit().

## ◆ reserve() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::reserve | ( |  | ) |

Equivalent to shrink_to_fit().

## ◆ reserve() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::reserve | ( | size_type | __res_arg | ) |
| constexpr

Attempt to preallocate enough memory for specified number of characters.

Parameters

  __res_arg | Number of characters required.

Exceptions

  std::length_error | If __res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

Definition at line 3668 of file cow_string.h.

References capacity(), get_allocator(), and std::size().

Referenced by std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::tr2::operator>>(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow().

## ◆ reserve() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::reserve | ( | size_type | __res_arg | ) |

Attempt to preallocate enough memory for specified number of characters.

Parameters

  __res_arg | Number of characters required.

Exceptions

  std::length_error | If __res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

## ◆ resize() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::resize | ( | size_type | __n | ) |
| inlineconstexpr

Resizes the string to the specified number of characters.

Parameters

  __n | Number of characters the string should contain.

This function will resize the string to the specified length. If the new size is smaller than the string's current size the string is truncated, otherwise the string is extended and new characters are default-constructed. For basic types such as char, this means setting them to 0.

Definition at line 1269 of file basic_string.h.

## ◆ resize() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::resize | ( | size_type | __n | ) |
| inline

Resizes the string to the specified number of characters.

Parameters

  __n | Number of characters the string should contain.

This function will resize the string to the specified length. If the new size is smaller than the string's current size the string is truncated, otherwise the string is extended and new characters are default-constructed. For basic types such as char, this means setting them to 0.

Definition at line 999 of file cow_string.h.

## ◆ resize() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::resize | ( | size_type | __n,
|  | _CharT | __c )
| constexpr

Resizes the string to the specified number of characters.

Parameters

  __n | Number of characters the string should contain.
  __c | Character to fill any new elements.

This function will resize the string to the specified number of characters. If the number is smaller than the string's current size the string is truncated, otherwise the string is extended and new elements are set to __c.

Definition at line 3816 of file cow_string.h.

References append(), erase(), and size().

Referenced by std::basic_string< _CharT >::resize().

## ◆ resize() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::resize | ( | size_type | __n,
|  | _CharT | __c )

Resizes the string to the specified number of characters.

Parameters

  __n | Number of characters the string should contain.
  __c | Character to fill any new elements.

This function will resize the string to the specified number of characters. If the number is smaller than the string's current size the string is truncated, otherwise the string is extended and new elements are set to __c.

## ◆ rfind() [1/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | _CharT | __c,
|  | size_type | __pos = npos ) const
| nodiscardconstexprnoexcept

Find last position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 780 of file basic_string.tcc.

References npos, and std::size().

## ◆ rfind() [2/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | _CharT | __c,
|  | size_type | __pos = npos ) const
| noexcept

Find last position of a character.

Parameters

  __c | Character to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for __c within this string. If found, returns the index where it was found. If not found, returns npos.

## ◆ rfind() [3/8]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| nodiscardconstexprnoexcept

Find last position of a C substring.

Parameters

  __s | C string to locate.
  __pos | Index of character to search back from.
  __n | Number of characters from s to search for.

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for the first __n characters in __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 757 of file basic_string.tcc.

References std::min(), npos, and std::size().

## ◆ rfind() [4/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n ) const
| noexcept

Find last position of a C substring.

Parameters

  __s | C string to locate.
  __pos | Index of character to search back from.
  __n | Number of characters from s to search for.

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for the first __n characters in __s within this string. If found, returns the index where it begins. If not found, returns npos.

## ◆ rfind() [5/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const
| inlinenodiscardconstexpr

Find last position of a C string.

Parameters

  __s | C string to locate.
  __pos | Index of character to start search at (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for the value of __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 3110 of file basic_string.h.

## ◆ rfind() [6/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos = npos ) const
| inlinenoexcept

Find last position of a C string.

Parameters

  __s | C string to locate.
  __pos | Index of character to start search at (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for the value of __s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2537 of file cow_string.h.

## ◆ rfind() [7/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = npos ) const
| inlinenodiscardconstexprnoexcept

Find last position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 3059 of file basic_string.h.

Referenced by std::basic_string< _CharT >::find_last_of(), std::basic_string< _CharT >::rfind(), std::basic_string< _CharT >::rfind(), std::basic_string< _CharT >::rfind(), and std::basic_string< _CharT >::rfind().

## ◆ rfind() [8/8]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::rfind | ( | const basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | size_type | __pos = npos ) const
| inlinenoexcept

Find last position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2506 of file cow_string.h.

## ◆ shrink_to_fit() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::shrink_to_fit | ( |  | ) |
| inlineconstexprnoexcept

A non-binding request to reduce capacity() to size().

Definition at line 1278 of file basic_string.h.

## ◆ shrink_to_fit() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::shrink_to_fit | ( |  | ) |
| inlinenoexcept

A non-binding request to reduce capacity() to size().

Definition at line 1007 of file cow_string.h.

## ◆ size() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::size | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Returns the number of characters in the string, not including any null-termination.

Definition at line 1217 of file basic_string.h.

Referenced by std::tr2::dynamic_bitset< _WordT, _Alloc >::dynamic_bitset(), std::basic_string< _CharT >::append(), std::basic_string< _CharT >::append(), std::basic_regex< char >::assign(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::assign(), std::basic_string< _CharT >::at(), std::basic_string< _CharT >::at(), std::basic_string< _CharT >::back(), std::basic_string< _CharT >::back(), std::basic_string< _CharT >::back(), std::basic_string< _CharT >::cend(), std::basic_string< _CharT >::compare(), std::basic_string< _CharT >::compare(), std::basic_string< _CharT >::compare(), std::basic_string< _CharT >::empty(), std::basic_string< _CharT >::end(), std::basic_string< _CharT >::end(), std::basic_string< _CharT >::end(), std::basic_string< _CharT >::find(), std::basic_string< _CharT >::find_first_not_of(), std::basic_string< _CharT >::find_first_of(), std::basic_string< _CharT >::find_last_of(), std::match_results< _BidirectionalIterator, polymorphic_allocator< sub_match< _BidirectionalIterator > > >< const char * >::format(), std::wstring_convert< _Codecvt, _Elem, _Wide_alloc, _Byte_alloc >::from_bytes(), std::basic_string< _CharT >::insert(), std::basic_string< _CharT >::length(), std::operator+(), std::operator+(), std::operator+(), std::operator+(), std::operator+(), std::basic_string< _CharT >::operator=(), std::operator==(), std::tr2::operator>>(), std::basic_string< _CharT >::operator[](), std::basic_string< _CharT >::operator[](), std::basic_string< _CharT >::pop_back(), std::basic_string< _CharT >::pop_back(), std::basic_string< _CharT >::push_back(), std::basic_string< _CharT >::replace(), std::basic_string< _CharT >::replace(), resize(), std::basic_stringbuf< char >::str(), std::wstring_convert< _Codecvt, _Elem, _Wide_alloc, _Byte_alloc >::to_bytes(), std::regex_traits< _CharT >::transform(), and std::regex_traits< _CharT >::transform_primary().

## ◆ size() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::size | ( |  | ) | const
| inlinenoexcept

Returns the number of characters in the string, not including any null-termination.

Definition at line 955 of file cow_string.h.

## ◆ starts_with() [1/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | _CharT | __x | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 3804 of file basic_string.h.

## ◆ starts_with() [2/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | _CharT | __x | ) | const
| inlinenoexcept

Definition at line 3203 of file cow_string.h.

## ◆ starts_with() [3/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | basic_string_view< _CharT, _Traits > | __x | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 3799 of file basic_string.h.

## ◆ starts_with() [4/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | basic_string_view< _CharT, _Traits > | __x | ) | const
| inlinenoexcept

Definition at line 3199 of file cow_string.h.

## ◆ starts_with() [5/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | const _CharT * | __x | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 3809 of file basic_string.h.

## ◆ starts_with() [6/6]

template<typename _CharT, typename _Traits, typename _Alloc>

bool std::basic_string< _CharT, _Traits, _Alloc >::starts_with | ( | const _CharT * | __x | ) | const
| inlinenoexcept

Definition at line 3208 of file cow_string.h.

## ◆ substr() [1/4]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string std::basic_string< _CharT, _Traits, _Alloc >::substr | ( | size_type | __pos,
|  | size_type | __n ) &&
| inlinenodiscardconstexpr

Definition at line 3507 of file basic_string.h.

## ◆ substr() [2/4]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string std::basic_string< _CharT, _Traits, _Alloc >::substr | ( | size_type | __pos = 0 | ) | &&
| inlinenodiscardconstexpr

Definition at line 3502 of file basic_string.h.

## ◆ substr() [3/4]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string std::basic_string< _CharT, _Traits, _Alloc >::substr | ( | size_type | __pos = 0,
|  | size_type | __n = npos ) const
| inlinenodiscardconstexpr

Get a substring.

Parameters

  __pos | Index of first character (default 0).
  __n | Number of characters in substring (default remainder).

Returns
  The new string.

Exceptions

  std::out_of_range | If __pos > size().

Construct and return a new string using the __n characters starting at __pos. If the string is too short, use the remainder of the characters. If __pos is beyond the end of the string, out_of_range is thrown.

Definition at line 3495 of file basic_string.h.

## ◆ substr() [4/4]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string std::basic_string< _CharT, _Traits, _Alloc >::substr | ( | size_type | __pos = 0,
|  | size_type | __n = npos ) const
| inline

Get a substring.

Parameters

  __pos | Index of first character (default 0).
  __n | Number of characters in substring (default remainder).

Returns
  The new string.

Exceptions

  std::out_of_range | If __pos > size().

Construct and return a new string using the __n characters starting at __pos. If the string is too short, use the remainder of the characters. If __pos is beyond the end of the string, out_of_range is thrown.

Definition at line 2917 of file cow_string.h.

## ◆ subview() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string_view< _CharT, _Traits > std::basic_string< _CharT, _Traits, _Alloc >::subview | ( | size_type | __pos = 0,
|  | size_type | __n = npos ) const
| inlinenodiscardconstexpr

Get a subview.

Parameters

  __pos | Index of first character (default 0).
  __n | Number of characters in subview (default remainder).

Returns
  The subview.

Exceptions

  std::out_of_range | If __pos > size().

Construct and return a subview using the __n characters starting at __pos. If the string is too short, use the remainder of the characters. If __pos is beyond the end of the string, out_of_range is thrown.

Definition at line 3526 of file basic_string.h.

## ◆ subview() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string_view< _CharT, _Traits > std::basic_string< _CharT, _Traits, _Alloc >::subview | ( | size_type | __pos = 0,
|  | size_type | __n = npos ) const
| inlinenodiscardconstexpr

Get a subview.

Parameters

  __pos | Index of first character (default 0).
  __n | Number of characters in subview (default remainder).

Returns
  The subview.

Exceptions

  std::out_of_range | If __pos > size().

Construct and return a subview using the __n characters starting at __pos. If the string is too short, use the remainder of the characters. If __pos is beyond the end of the string, out_of_range is thrown.

Definition at line 2936 of file cow_string.h.

## ◆ swap() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::swap | ( | basic_string< _CharT, _Traits, _Alloc > & | __s | ) |
| constexprnoexcept

Swap contents with another string.

Parameters

  __s | String to swap with.

Exchanges the contents of this string with that of __s in constant time.

Definition at line 3694 of file cow_string.h.

References basic_string(), and get_allocator().

Referenced by std::basic_string< _CharT >::assign(), and std::basic_string< _CharT >::operator=().

## ◆ swap() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_string< _CharT, _Traits, _Alloc >::swap | ( | basic_string< _CharT, _Traits, _Alloc > & | __s | ) |
| noexcept

Swap contents with another string.

Parameters

  __s | String to swap with.

Exchanges the contents of this string with that of __s in constant time.

## Friends And Related Symbol Documentation

## ◆ basic_stringbuf

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename, typename, typename>

friend class basic_stringbuf
| friend

Definition at line 3846 of file basic_string.h.

## Member Data Documentation

## ◆ _M_allocated_capacity

template<typename _CharT, typename _Traits, typename _Alloc>

size_type std::basic_string< _CharT, _Traits, _Alloc >::_M_allocated_capacity

Definition at line 237 of file basic_string.h.

## ◆ _M_local_buf

template<typename _CharT, typename _Traits, typename _Alloc>

_CharT std::basic_string< _CharT, _Traits, _Alloc >::_M_local_buf[_S_local_capacity+1]

Definition at line 236 of file basic_string.h.

## ◆ npos

template<typename _CharT, typename _Traits, typename _Alloc>

const size_type std::basic_string< _CharT, _Traits, _Alloc >::npos
| static

Value returned by various member functions when they fail.

Definition at line 127 of file basic_string.h.

Referenced by std::bitset< _Nb >::bitset(), std::tr2::dynamic_bitset< _WordT, _Alloc >::dynamic_bitset(), find(), find(), find_first_not_of(), find_first_not_of(), find_first_of(), find_last_not_of(), find_last_not_of(), find_last_of(), rfind(), and rfind().

The documentation for this class was generated from the following files:

- basic_string.h
- cow_string.h
- basic_string.tcc